#ifndef __t51handle_h__
#define __t51handle_h__

#define WM_USER_LECHIP WM_USER+1

#define LE_ADD		1
#define LE_CLEAR	2
#define LE_UPDATE	3
//#define LE_DEL		4
#define LE_STATUS_CHANGE		9
#define LE_END		10
 
#define __mac_is_invalid(mac ) \
(mac[0]==0&&mac[1]==0&&mac[2]==0&&mac[3]==0&&mac[4]==0&&mac[5]==0)
 
 
int handle_t51_msg(HWND) ;
void t55_get_fms();
void t55_reset_fms();
void t55_get_wirt();
void t55_reset_wirt();
 void t55_get_zeit();
 void t55_reset_zeit();
 void t55_get_reifen();
 void t55_reset_reifen();
 void t55_send_alarm(BYTE*);
void t51_save_to_flash();
void CleanupInit(); 
 inline DWORD BY2DW(DWORD& dw, unsigned char* by)
{
	dw = ( (by[0]&0xff)<<24) + (((by[1])&0xff)<<16) + (((by[2])&0xff)<<8 )+ (by[3]&0xff) ;
	return dw;
}
 inline DWORD BY2HW(DWORD& dw, unsigned char* by)
{
	dw = ( (by[0]&0xff)<<8) + ((by[1])&0xff )  ;
	return dw;
}
/* #define BY2DW(  dw,by)  \
	dw = ( (((unsigned char*)by)[0]&0xff)<<24) + ((((unsigned char*)by)[1])&0xff<<16) + ((((unsigned char*)by)[2])&0xff<<8 )+ (((unsigned char*)by)[3]&0xff)
 #define BY2HW(  dw,by)  \
	dw = ( (((unsigned char*)by)[0]&0xff)<<8) + ((((unsigned char*)by)[1])&0xff )  
*/
#define DW2BY( dw,by)  \
	by[0] = (dw>>24)&0xff, by[1]=(dw>>16)&0xff , by[2]=(dw>>8)&0xff, by[3]=(dw)&0xff

typedef void (*UI_CALLBACK_FUNC)(unsigned char* data,HWND);
int hex_to_val( char ch);
void register_ui_callback(int id,UI_CALLBACK_FUNC func);

struct TIRE_CFG {
	UINT nID; //tire identify
	float pressure[4];
	float temp[4];
};
 typedef struct tFMS_SAVE {
	int month;
	float f8;
	float f9;
 }FMS_SAVE;
void load_tire_cfg();
void save_tire_cfg();
void load_tank_data();
void save_tank_data();
void load_fms_data();
void save_fms_data();
TIRE_CFG* find_cfg(int tire);
	int get_color(float press , float tmp, int tire);
int MyMBS2WCS(const char* mbs, wchar_t* wcs,int bUnicode);
TCHAR* get_month( int month);

#define ByteInvalid(b) ( (b&0xff)==0xff)
#define ShortInvalid(b) (ByteInvalid(b[0]) &&ByteInvalid(b[1]) )
#define LongInvalid(b) (ByteInvalid(b[0]) &&ByteInvalid(b[1]) && ByteInvalid(b[2]) &&ByteInvalid(b[3]) )
#endif
