#include "Stdafx.h"
#include "PublicCtrl.h"
#include "drawlib.h"
//#include "SingleToneHold.h"
#ifndef IDB_BTN_DISABLE
#define IDB_BTN_DISABLE -1
#endif
//MenuPageDC MenuDC;


CSimpleMap<UINT, BKIMG_T*>  g_mapBK;

static void DrawPressedState(HDC hDC, CRect re)
{
//CRect re(m_Rect[m_nPress].left,m_Rect[m_nPress].top,m_Rect[m_nPress].left+m_Rect[m_nPress].right,m_Rect[m_nPress].top+m_Rect[m_nPress].bottom);
		re.bottom-=2; re.right-=2;re.top+=1;re.left+=1;
		 DrawDC  Draw(hDC);
		HBRUSH hbr=(HBRUSH) ::SelectObject(hDC, GetStockObject(NULL_BRUSH));
		//Draw.DrawRoundRect(&re, 3, 0x80FF, 15,14); //HS
		::SelectObject(hDC, hbr);
}
MemDC::MemDC(HDC hdc,int width,int height)	: CompatibleDC(hdc)
{
	BITMAPINFO	bitmapinfo	= {0};
	BYTE *		pbuf		= NULL;

	bitmapinfo.bmiHeader.biSize		= sizeof(BITMAPINFOHEADER);
	bitmapinfo.bmiHeader.biWidth	= width;
	bitmapinfo.bmiHeader.biHeight	= height;
	bitmapinfo.bmiHeader.biPlanes	= 1;
	bitmapinfo.bmiHeader.biBitCount = 24;

	m_hbitmap = ::CreateDIBSection(m_hdc,&bitmapinfo,DIB_RGB_COLORS,(void**)&pbuf,NULL,0);
	m_hgdiobj = ::SelectObject(m_hdc,m_hbitmap);

	::GetObject(m_hbitmap, sizeof(BITMAP), &m_bmpInfo);
}

void MemDC::ChangeObj(HBITMAP hbitmap)	
{
	::SelectObject(m_hdc,m_hgdiobj);
	::DeleteObject(m_hbitmap);
	m_hgdiobj =::SelectObject(m_hdc,hbitmap);
	m_hbitmap = hbitmap;

	::GetObject(m_hbitmap, sizeof(BITMAP), &m_bmpInfo);
}

MemDC::~MemDC()
{
	::SelectObject(m_hdc,m_hgdiobj);
	::DeleteObject(m_hbitmap);
}


void CCanvas::DrawText(TCHAR const * psztext,const RECT & rect,UINT format)
{
	::DrawText(m_hdc,psztext, -1, (RECT *)&rect,format);
}

void CCanvas::Line(int x1, int y1, int x2, int y2)
{
	::MoveToEx(m_hdc, x1, y1, 0);
	::LineTo(m_hdc, x2, y2);
}
void CCanvas::DrawRect(int x0,int y0,int x1,int y1)
{
	Line(x0,y0,x1,y0);Line(x0,y0,x0,y1);
	Line(x0,y1,x1,y1);Line(x1,y0,x1,y1);
}
void CCanvas::RoundRectangle(int x,int y,int width,int hight)
{
	::RoundRect(m_hdc,x,y,width,hight,5,5);
	
}
void CCanvas::BitBlt(HBITMAP hbitmap, int x,int y,BOOL bTrans)
{
	CDC compatibledc;
	compatibledc.CreateCompatibleDC(m_hdc);
	BOOL b= 0;
	DWORD err = 0;
	HBITMAP hOld = compatibledc.SelectBitmap(hbitmap);
	BITMAP bm;
	::GetObject(hbitmap, sizeof(BITMAP), &bm);
	int width,hight;
	width = bm.bmWidth;hight=bm.bmHeight;
	if(bTrans)
		b = ::TransparentBlt(m_hdc,x,y,width,hight, compatibledc,0,0,width,hight, RGB(0,128,128));
	else
		b= ::BitBlt(m_hdc,x,y,width,hight,compatibledc,0,0,SRCCOPY);
	if(!b)
		err = GetLastError();
	compatibledc.SelectBitmap(hOld);
	compatibledc.DeleteDC();
}


void CCanvas::BitBlt(HBITMAP hbitmap, DWORD rop, int x,int y,int width,int hight,int bTrans)
{
	DWORD err;
	CDC compatibledc;
	compatibledc.CreateCompatibleDC(m_hdc);

	ObjHold<HBITMAP> bmphold(compatibledc,hbitmap);
	if(bTrans)::TransparentBlt(m_hdc,x,y,width,hight, compatibledc,x,y,width,hight, RGB(0,128,128));
	else ::BitBlt(m_hdc,x,y,width,hight,compatibledc,0,0,rop);
BOOL b;
	b = compatibledc.DeleteDC();
	if(!b)
	{
		err = GetLastError();
	}
}


void CCanvas::BitBlt(HBITMAP hbitmap,  DWORD rop, const RECT & rect,int x ,int y,int bTrans)
{
	BOOL bOK;
	DWORD err;
	CDC compatibledc;
	compatibledc.CreateCompatibleDC(m_hdc);

	ObjHold<HBITMAP> bmphold(compatibledc,hbitmap);
	if(bTrans) bOK = ::TransparentBlt(m_hdc,rect.left,rect.top,rect.right,rect.bottom, compatibledc,x,y,rect.right,rect.bottom, RGB(0,128,128));
	else ::BitBlt(m_hdc,rect.left,rect.top,rect.right,rect.bottom,compatibledc,x,y,rop);
	if(!bOK)
	{
		 err= GetLastError();
	}
	BOOL b;
	b = compatibledc.DeleteDC();
	if(!b)
	{
		err = GetLastError();
	}
}

void CCanvas::BitBlt(HDC hdc,  DWORD rop, int x,int y,int width,int hight) 
{
		::BitBlt(m_hdc,x,y,width,hight,hdc,0,0,rop);
		//::TransparentBlt(m_hdc,x,y,width,hight, hdc,x,y,width,hight, RGB(0,128,128));
}

void CCanvas::BitBlt(HDC hdc,  DWORD rop, const RECT & rect,int x ,int y) 
{
		::BitBlt(m_hdc,rect.left,rect.top,rect.right,rect.bottom,hdc,x,y,rop);
		//::TransparentBlt(m_hdc,rect.left,rect.top,rect.right,rect.bottom, hdc,         x,y,rect.right,rect.bottom, RGB(0,128,128));
}

void CODButtonImp2::DrawItem(HDC hDC)
{
	if(!m_bShow) return;
	CCanvas canvas(hDC);

	HBITMAP hbitmap;

	//m_Bitmap[0].make_transparent( lpdis->hDC);
	if(BtOnOff )//|| (m_Bitmap_off[0]==0) || (m_Bitmap_off[1]==0)  )
	{
		//XTrace(TEXT("Checked: %d  "),m_check);
		//XTrace(TEXT("Pressed: %d  "),m_pressed);
		if(m_chimgID==0||m_chimgID==-1)  {
			hbitmap = m_Bitmap[0];
			//XTrace(TEXT("bm0(a) "));
		}else {
			if(m_check) {
				if (m_Bitmap_Check.m_hBitmap == 0) {
					if (m_pressed && m_Bitmap[1].m_hBitmap != 0) {
						hbitmap = m_Bitmap[1];
						//XTrace(TEXT("bm1(a) "));
					}else {
						hbitmap = m_Bitmap[0];
						//XTrace(TEXT("bm0(b) "));
					}
				}else {
					hbitmap = m_Bitmap_Check;
					//XTrace(TEXT("bmC "));
				}

			} else { 
				if (m_pressed && m_Bitmap[1].m_hBitmap != 0) {
					hbitmap = m_Bitmap[1];
					//XTrace(TEXT("bm1 (c) "));
				}else {
					hbitmap = m_Bitmap[0];
					//XTrace(TEXT("bm0 (c) "));
				}
			}
		}

	}
	else
	{	
		if (m_Bitmap_off[0].m_hBitmap != 0) {
		hbitmap = m_Bitmap_off[0];
			//XTrace(TEXT("bmo0 (d) "));
		} else {
			hbitmap = m_Bitmap[0];
			//XTrace(TEXT("bm0 (d) "));
		}

		if(hbitmap==NULL)
		{
			m_Bitmap_off[0].LoadBitmap(IDB_BTN_DISABLE);
			hbitmap= m_Bitmap_off[0];
		}
		//hbitmap = (0 != (lpdis->itemState & ODS_SELECTED)) 
		//				  ? m_Bitmap_off[1] : m_Bitmap_off[0];
	}
	//XTrace(TEXT("\r\n"));
	if(hbitmap)
	{
	
		int width = m_rcButton.Width();
		int height = m_rcButton.Height();

		CRect rc(m_rcButton.left,m_rcButton.top,width,height);	
		canvas.BitBlt(hbitmap,SRCCOPY,rc);
	}
    
	if(m_check)
	{

		if(m_Bitmap_Check.m_hBitmap)
		{
			//canvas.BitBlt(m_Bitmap_Check.m_hBitmap,m_ptCheck.x,m_ptCheck.y);
				
		}
	}
	
	if(ButtonCaption) 
	{
	    DrawDC  Draw(hDC);
   
		Draw.SetDrawBkMode(TRANSPARENT);
		Draw.SetDrawTextColor(m_clrText);
/*		if (FontBold <= 400) {
			Draw.SetDrawFontSize(FontHight,FontWidth,FontBold,__FONT_NORMAL__);
		} else {
			Draw.SetDrawFontSize(FontHight,FontWidth,FontBold,__FONT_BOLD__);
		}
*/		
		Draw.SetDrawFontSize(FontHight,FontWidth,FontBold,__FONT_NORMAL__);
		if(BtOnOff && !m_bGreyTitle){
			if(m_clrText!=RGB(0,0,0))
				Draw.DrawStringRect(ButtonCaption,&FontRect,m_nTxtAlign);
			else Draw.DrawGPSOverIPStringRect(ButtonCaption,&FontRect,m_nTxtAlign);
		}else {
			if(m_clrText!=RGB(0,0,0))
				Draw.DrawStringRect(ButtonCaption,&FontRect,m_nTxtAlign);
			else Draw.DrawGPSOverIPStringRectDisable(ButtonCaption,&FontRect,m_nTxtAlign);
		}

	}
	if(m_idTag && m_Bitmap_Check.m_hBitmap)
	{
		int x = m_ptTag.x+ m_rcButton.left;
		int y = m_ptTag.y+ m_rcButton.top;
		canvas.BitBlt(m_Bitmap_Check.m_hBitmap,x,y,FALSE); 
		 
	}
	
}
LRESULT CODButtonImp2::OnMouseMove(UINT, CPoint pt)
{
	return 1;
}
LRESULT CODButtonImp2::OnLButtonDown(UINT, CPoint pt)
{
	// TODO: Add your message handler code here and/or call default
	if(m_bShow && m_rcButton.PtInRect(pt))
	{
		//SendMessage(m_hWnd,WM_COMMAND,m_nCmdID,0);
		SetPressed(TRUE);
		return 1;
	}
	return 0;
}

LRESULT CODButtonImp2::OnLButtonUp(UINT, CPoint pt)
{
	if(m_bShow && m_rcButton.PtInRect(pt) && m_pressed)
	{
		if(BtOnOff )
		{
			Invalidate();
			if(m_nCmdID2>0)
			{
				CRect rect;
				GetClientRect(&rect);
				if(pt.x >= (rect.left+rect.right)/2)  SendMessage(m_hWnd,WM_COMMAND,m_nCmdID2,0);
				else SendMessage(m_hWnd,WM_COMMAND,m_nCmdID,0);
			}else 
				SendMessage(m_hWnd,WM_COMMAND,m_nCmdID,0);
			
		}
		SetPressed(FALSE);
		return 1;
	}
	SetPressed(FALSE);
	return 0;
}


DWORD CreateProg(BOOL nrelation,LPTSTR pszProg,LPTSTR pszParam)
{
	PROCESS_INFORMATION pinfo = {0};
	DWORD dwExitCode=0; // {^ǭ

	if (1 == nrelation)
	{
		TCHAR szFile[MAX_PATH] = {0};

		::GetModuleFileName( 0, szFile, MAX_PATH );
	  
		TCHAR* p = _tcsrchr( szFile, '\\' );
		if (p == 0) return 0;
		_tcscpy( p + 1, pszProg);
		
		::CreateProcess(szFile,pszParam,NULL,NULL,FALSE,0,NULL,NULL,NULL,&pinfo);
	}
	else
	{
		BOOL b = ::CreateProcess(pszProg,pszParam,NULL,NULL,FALSE,0,NULL,NULL,NULL,&pinfo);
		if(!b)
			dwExitCode = GetLastError();
	}
	
	if(::WaitForSingleObject(pinfo.hThread,INFINITE) != WAIT_FAILED)  // Daniel@20071219 {^ǭ
		 GetExitCodeProcess(pinfo.hProcess,&dwExitCode);              // dwExitCode ^ǭ

	return dwExitCode;
	

}


void CreateProg_NoWait(BOOL bRelativePath,LPCTSTR pszProg,LPCTSTR pszParam,HANDLE *hHND)
{
	PROCESS_INFORMATION pinfo = {0};

	if (1 == bRelativePath)
	{
		TCHAR szFile[MAX_PATH] = {0};

		::GetModuleFileName( 0, szFile, MAX_PATH );
	  
		TCHAR* p = _tcsrchr( szFile, '\\' );
		if (p == 0) return ;
		_tcscpy( p + 1, pszProg);
		
		::CreateProcess(szFile,pszParam,NULL,NULL,FALSE,0,NULL,NULL,NULL,&pinfo);
	}
	else
	{
		::CreateProcess(pszProg,pszParam,NULL,NULL,FALSE,0,NULL,NULL,NULL,&pinfo);
	}
	if(hHND)
		*hHND=pinfo.hProcess;

}



void DrawObjList::PaintBK(HDC hdc,CRect* prc)
{
	CCanvas canvas(hdc);
	if(prc==NULL)
	{
		//if ( (m_ifpopup == TRUE) || (m_twoIcon == TRUE) )
		//	canvas.BitBlt(m_BmpBK,SRCCOPY,CRect(PopDC_left,PopDC_top,PopDC_right,PopDC_bottom));
		//else
		{	
			//canvas.BitBlt(m_BmpBK,SRCCOPY,CRect(MenuDC_left,MenuDC_top,MenuDC_right,MenuDC_bottom));
			 canvas.BitBlt(m_BmpBK, MenuDC_left,MenuDC_top,FALSE);
		}
	}
	else
	{
		canvas.BitBlt(m_BmpBK,SRCCOPY,*prc);
	}
	if(m_BmpIcon.m_hBitmap)
	canvas.BitBlt(m_BmpIcon,SRCCOPY,m_rtIcon);

	if (m_twoIcon == TRUE)
		canvas.BitBlt(m_BmpIcon2,SRCCOPY,m_rtIcon2);
}


void DrawObjList::PaintObj(HDC hdc)
{
	CCanvas canvas(hdc);

	for (DWORD index=0 ; index<GetCount() ; index++)
	{
		m_Items[index]->Paint(hdc,m_BmpBK);
	}
}



//===============================================================
//
//Class DrawKeyPad  
//================================================================
BOOL CDrawKeyPad::CreateWnd(HWND hParentWnd,UINT uId,UINT uRes, BUTTON_ITEM *KeyPad_Item,int Number,LONG x,LONG y,int w,int h)
{
	CRect rtWnd;
	UINT nIDBK = uRes;
	NumberOfItem   =Number;
	MsgID          =uId;
	KeyItem        =KeyPad_Item;
	//m_uRes = uRes;
	m_rcButton.SetRect(x,y, x+w,y+h);
	//Width=w;
	//Height=h;
	//StartX=x;
	//StartY=y;
	m_hWnd = hParentWnd;
	if(nIDBK==0) nIDBK = IDBI_BK;
	for (int i=0;i<Number;i++) {
		SetImageTrans(&kbtn[i],nIDBK,IDBI_KEYPAD_BUTTON, KeyItem[i].rt.left, KeyItem[i].rt.top);
	}
	if(Number>12 && m_bNoSpace==FALSE)
	{
		SetImageTrans(&kbtn[Number],nIDBK,IDBI_BTN_EMPTYDOUBLE, __X+_KW*4,  __Y+_KH*2);
		SetImageTrans(&kbtn[Number+1],nIDBK,IDBI_BTN_EMPTYDOUBLE_DN, __X+_KW*4,  __Y+_KH*2);
	}
#if 0
	rtWnd.left =x;
	rtWnd.top  =y;
	rtWnd.right  =x+Width;
	rtWnd.bottom=y+Height;

	//CompatibleDC m_dc(GetDC());   
	m_BackGroundDC = new MemDC(NULL,Width,Height);	
    

	CMyBitmap m_Bmp;
	CCanvas canvas(m_BackGroundDC->GetDC());
	
	//KWI
	if(m_bpBk)
	{
		canvas.BitBlt(m_Bmp.LoadBitmap(m_bpBk),SRCCOPY,CRect(0,0,Width,Height));
		m_Bmp.DeleteObject();
	}
	else
	{
		if(MenuDC.GetDC())
		{
			//m_BackGroundDC = new MemDC(NULL,/*Width*/Rect.right,/*Height*/Rect.bottom);	
			CCanvas canvas(m_BackGroundDC->GetDC());
			canvas.BitBlt(MenuDC.GetDC(),SRCCOPY,CRect(0,0,Width,Height),x,y);
		}

	}
	
	m_Bmp.LoadBitmap(m_uRes);
	for (int i=0;i<Number;i++)
	{
        //canvas.BitBlt(m_Bmp.LoadBitmap(KeyPad_Item[i].bmpId),SRCCOPY,CRect(KeyPad_Item[i].rt.left-x,KeyPad_Item[i].rt.top-y,44,44));
	    //m_Bmp.DeleteObject();
		int xo,yo;
		yo = (KeyPad_Item[i].bmpId/10)*44;
		xo = (KeyPad_Item[i].bmpId%10)*44;
		canvas.BitBlt(m_Bmp.m_hBitmap,SRCCOPY,CRect(KeyPad_Item[i].rt.left-x,KeyPad_Item[i].rt.top-y,44,44), xo,yo);
	}	
	
	m_Bmp.DeleteObject();
#endif
	//
	//DWORD dwStyle = WS_CHILD|WS_VISIBLE|BS_OWNERDRAW|BS_NOTIFY;
	return 1;//(NULL != Create(hParentWnd,rtWnd,0,dwStyle,0,uId));

}

void CDrawKeyPad::DrawItem(HDC hDC,HDC hDCPaint)
{
	//Test
	CCanvas canvasmaster(hDCPaint);

	//Test Ende
	CCanvas canvas(hDC);
	int x = m_rcButton.left,y=m_rcButton.top;
	CMyBitmap m_Bmp;
	if(m_bpBk!=0 && m_bpBk!=-1)
	{
		//canvas.BitBlt(m_Bmp.LoadBitmap(m_bpBk),SRCCOPY,CRect(x,y,m_rcButton.Width(),m_rcButton.Height()));
#ifndef __PNG_CACHE__		
		//m_Bmp.DeleteObject();
#endif
	}
	if (LayoutMode==false && NumberOfItem>10)
	{
		if (KeyIndex == 24 || KeyIndex ==25) {
			canvas.BitBlt(kbtn[NumberOfItem + 1].m_hBitmap,SRCCOPY,CRect(__X+_KW*4,  __Y+_KH*2,132,66));
		} else {
			canvas.BitBlt(kbtn[NumberOfItem].m_hBitmap,SRCCOPY,CRect(__X+_KW*4,  __Y+_KH*2,132,66));
		}
	}
	int pb=-1;
	for (int i=0;i<NumberOfItem;i++)
	{
        //canvas.BitBlt(m_Bmp.LoadBitmap(KeyPad_Item[i].bmpId),SRCCOPY,CRect(KeyPad_Item[i].rt.left-x,KeyPad_Item[i].rt.top-y,44,44));
	    //m_Bmp.DeleteObject();
		if (KeyItem[i].uId !=0) {
			if (KeyIndex != i) {
				canvas.BitBlt(kbtn[i].m_hBitmap,SRCCOPY,CRect(KeyItem[i].rt.left,KeyItem[i].rt.top,66,66));
				TCHAR text [2] ;
				text[0]=KeyItem[i].uId;
				text[1]=0;
				SetTextColor(canvas.m_hdc,RGB(250,250,250));
				SetBkMode(canvas.m_hdc,TRANSPARENT);
				HFONT m_Oldfont=(HFONT )::SelectObject(canvas.m_hdc,ghKeyFont);		
				canvas.DrawText(text,CRect(KeyItem[i].rt.left,KeyItem[i].rt.top,KeyItem[i].rt.left+66,KeyItem[i].rt.top+66),DT_CENTER|DT_VCENTER);
				SelectObject(canvas.m_hdc,m_Oldfont);
			} else { //Gedrckte Taste zeichnen
				/*CMyBitmap temp;
				SetImageTrans(&temp,IDBI_BK,IDBI_BTN_EMTPY_DN, KeyItem[i].rt.left-10,KeyItem[i].rt.top-86);
				canvasmaster.BitBlt(temp.m_hBitmap,SRCCOPY,CRect(KeyItem[i].rt.left-10,KeyItem[i].rt.top-84,86,150));
				temp.DeleteObject();
				//*/
			}
		}
	}
	if (KeyIndex >=0 && KeyItem[KeyIndex].uId !=0) {
		HFONT m_Oldfont=NULL;
		if(hwndeditbox){
		//Draw text of the editbox to the hdc, since this contol cannot be owerdrwan, so it is made invisible and copied the content.
		TCHAR  edittext [255];
		int len = 255;
		CRect re;
		::GetWindowText(hwndeditbox,edittext,len);
		::GetWindowRect(hwndeditbox,&re);
		SetTextColor(canvas.m_hdc,RGB(0,0,0));
		SetBkMode(canvas.m_hdc,TRANSPARENT);
		m_Oldfont = (HFONT )::SelectObject(canvas.m_hdc,ghEditFont);	
		int line=SendMessage(hwndeditbox, EM_GETFIRSTVISIBLELINE, 0, 0L);
		re.top -= line * FontHeight;
		canvas.DrawText(edittext,re,DT_LEFT | DT_WORDBREAK | DT_EDITCONTROL);
		SelectObject(canvas.m_hdc,m_Oldfont);
		
		}
		//Calculate Transparency of the pressed button and paint to the dc
		CMyBitmap temp;
		SetImageTransDC(&temp,canvas.m_hdc,IDBI_BTN_EMTPY_DN, KeyItem[KeyIndex].rt.left-10,KeyItem[KeyIndex].rt.top-84);
		//SetImageTrans(&temp,IDBI_BK,IDBI_BTN_EMTPY_DN, KeyItem[KeyIndex].rt.left-10,KeyItem[KeyIndex].rt.top-86);
		BITMAP bm;
		::GetObject(temp, sizeof(BITMAP), &bm);

		canvas.BitBlt(temp.m_hBitmap,SRCCOPY,CRect(KeyItem[KeyIndex].rt.left-10,KeyItem[KeyIndex].rt.top-84,86,150));
		//temp.DeleteObject();
		//Draw letter in huge size on the pressed button
		TCHAR text [2] ;
		text[0]=KeyItem[KeyIndex].uId;
		text[1]=0;
		SetTextColor(canvas.m_hdc,RGB(250,250,250));
		m_Oldfont=(HFONT )::SelectObject(canvas.m_hdc,ghHugeFont);	
		canvas.DrawText(text,CRect(KeyItem[KeyIndex].rt.left-10,KeyItem[KeyIndex].rt.top-84,KeyItem[KeyIndex].rt.left-10 + 86,KeyItem[KeyIndex].rt.top-84 + 84),DT_CENTER | DT_VCENTER);
		if(m_Oldfont) SelectObject(canvas.m_hdc,m_Oldfont);

	} else {
		if(hwndeditbox) ::ShowWindow(hwndeditbox,SW_SHOW);
	}	
	//::InvalidateRect(m_hWnd,new CRect(0,0,800,480),true);
#ifndef __PNG_CACHE__	
	//m_Bmp.DeleteObject();
#endif
}


LRESULT CDrawKeyPad::OnLButtonDown(UINT ctl, CPoint pt)
{
	CRect  rect;
    CBitmap m_Bmp;
	
	//CCanvas canvas(hDC);
	int Point_X,Point_Y; 
	Point_X = pt.x; 
	Point_Y = pt.y;
//	int y = HIWORD(lParam);
	if(!m_rcButton.PtInRect(pt)) return 0;
    
	//::ShowWindow(hwndeditbox,SW_HIDE);

    for(int i=0;i<NumberOfItem;i++)
	{
		rect=KeyItem[i].rt;
		
		//rect.top -=StartY;
		//rect.left-=StartX;
		rect.bottom +=rect.top;
		rect.right  +=rect.left;

        if(((Point_X>rect.left)&&(Point_X<rect.right))&&((Point_Y>rect.top)&&(Point_Y<rect.bottom)))
		{
             ::ShowWindow(hwndeditbox,SW_HIDE);
			 HDC hDC=GetDC(m_hWnd);
			DrawPressedState(hDC, rect);
			ReleaseDC(m_hWnd,hDC);
			KeyIndex=i;
			 break;
		}

	}
	if ( m_bNoSpace==FALSE && NumberOfItem>12 &&(KeyIndex==24 || KeyIndex==24+1) ) {
		if (!this->LayoutMode) {
			CRect rc(KeyItem[24].rt.left,KeyItem[24].rt.top,KeyItem[24].rt.left + 132,KeyItem[24].rt.top+66);
			::InvalidateRect(m_hWnd,&rc ,0);
			::PostMessage(m_hWnd,MsgID,32,0);
		}
	} else if (KeyIndex >= 0 && KeyItem[KeyIndex].uId !=0) {
		::PostMessage(m_hWnd,MsgID,KeyItem[KeyIndex].uId,0);
		CRect rc(KeyItem[KeyIndex].rt.left-10,KeyItem[KeyIndex].rt.top-84,KeyItem[KeyIndex].rt.left - 10 + 86,KeyItem[KeyIndex].rt.top - 84 + 150);
		::InvalidateRect(m_hWnd,&rc ,0);
	}

	//ReleaseDC(m_hWnd,hDC);
	Flag_key = true;
	return (KeyIndex!=-1 )?1:0;
}
LRESULT CDrawKeyPad::OnLButtonUp(UINT ctl, CPoint pt)
{
	//HDC hDC=GetDC();
	//CCanvas canvas(hDC);
	
	if(Flag_key == true && KeyIndex!=-1)
	{
		//canvas.BitBlt(m_BackGroundDC->GetDC(),SRCCOPY,CRect(0,0,Width,Height));

		CRect rect;
		rect=KeyItem[KeyIndex].rt;
		
		//rect.top -=StartY;
		//rect.left-=StartX;
		rect.bottom +=rect.top;
		rect.right  +=rect.left;

		//::InvalidateRect(m_hWnd,&rect,0);
		if ( m_bNoSpace==FALSE  && NumberOfItem>12 && (KeyIndex==24 || KeyIndex==24+1)) 
		{
			CRect rc(KeyItem[24].rt.left,KeyItem[24].rt.top,KeyItem[24].rt.left + 132,KeyItem[24].rt.top+66);
			::InvalidateRect(m_hWnd,&rc ,0);
		} else {
			CRect rc(KeyItem[KeyIndex].rt.left-10,KeyItem[KeyIndex].rt.top-84,KeyItem[KeyIndex].rt.left + 86,KeyItem[KeyIndex].rt.top+150) ;
			::InvalidateRect(m_hWnd,&rc ,0);
		}
		KeyIndex=-1;
		//::UpdateWindow(m_hWnd);
		Flag_key = false;
		return m_rcButton.PtInRect(pt) ;
	}
	//ReleaseDC(hDC);
	return 0 ;
}


BOOL CTextEdit::CreateWnd(HWND hParentWnd,LONG x,LONG y,LONG Width,LONG Height,UINT uId,LONG MaxChar,DWORD dwStyle)
{
	CRect rtWnd;
    HWND h_Wnd;
	
	rtWnd.left  =x;
	rtWnd.top   =y;
	rtWnd.right =x+Width;
	rtWnd.bottom=y+Height;

	//DWORD dwStyle = WS_CHILD|WS_VISIBLE|ES_NOHIDESEL|ES_MULTILINE;WS_EX_CLIENTEDGE
	h_Wnd=Create(hParentWnd,rtWnd,0,dwStyle,0,uId);
	
	SetLimitText(MaxChar);
    SetFocus();
	if((dwStyle&ES_NOHIDESEL)==0)
	{
		m_bNoMouse = 1;
	}
    if(h_Wnd)
        return true;
	else
        return false;

}
BOOL CTextEdit::InsertChar(TCHAR Char)
{
	WCHAR Key[2];
	int nStart,nEdit;
    
	Key[0]=Char;
	Key[1]=0;

	GetSel(nStart,nEdit);

	InsertText(nStart,(WCHAR *)&Key,0,0);

    return 0;
}
BOOL CTextEdit::BackSpace()
{
	TCHAR GetText[MsgTextMaxLen];
	int SelStart,SelEnd;
	GetSel(SelStart,SelEnd);

	if(SelStart == SelEnd)
	{
		GetWindowText(GetText,MsgTextMaxLen);
		if(GetText[SelStart-2] == 13 && GetText[SelStart-1] == 10)
			SetSel(SelStart-2,SelEnd);
		else
			SetSel(SelStart-1,SelEnd);
	}
	else
	{
		SetSel(SelStart,SelEnd);
	}
	Clear();

    return 1;
}
LRESULT CTextEdit::OnErasebkgnd(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	int nLen = ::GetWindowTextLength(m_hWnd);
	if(nLen==0 && m_pTxtHelp){
		bHandled = 1;return 1;
	}else bHandled = 0;
	return 0;
}
    //LRESULT OnLButton(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
LRESULT CTextEdit::OnExit(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled) {
	//::HideCaret((HWND) lParam);
	return 1;
}
LRESULT CTextEdit::OnPaint(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
		int nLen = ::GetWindowTextLength(m_hWnd);
		if( nLen>0 || m_pTxtHelp==NULL){ bHandled=0;return 0;}
		RECT rc;
		
		if(::GetFocus()==m_hWnd) { 
			bHandled=0;

			PAINTSTRUCT ps;
			HWND hwnd = m_hWnd;
			HDC hdc = ::BeginPaint(hwnd, &ps);
			::GetClientRect(hwnd,&rc);
			rc.bottom+=3;// 
			HBRUSH m_br = ::CreateSolidBrush(0xffffff);
			::FillRect(hdc, &rc, m_br);
			DrawDC draw(hdc);
			draw.SetDrawTextColor(RGB(255,255,255));
			draw.SetDrawBkMode(TRANSPARENT);
			draw.SetDrawFontSize(FontHeight+2,0,FW_NORMAL,__FONT_NORMAL__);
			draw.DrawStringRect(m_pTxtHelp,&rc,DT_LEFT);
			//::DrawText(hdc,m_pTxtHelp ,wcslen(m_pTxtHelp) ,&rc,DT_LEFT);
			::DeleteObject(m_br);
			::EndPaint(hwnd, &ps);
			return 0;
		}
		PAINTSTRUCT ps;
		HWND hwnd = m_hWnd;
		HDC hdc = ::BeginPaint(hwnd, &ps);
		::GetClientRect(hwnd,&rc);
		rc.bottom+=3;// 
		HBRUSH m_br = ::CreateSolidBrush(0xffffff);
		::FillRect(hdc, &rc, m_br);
		DrawDC draw(hdc);
	    draw.SetDrawTextColor(RGB(82,82,82));
		draw.SetDrawBkMode(TRANSPARENT);
		draw.SetDrawFontSize(FontHeight+2,0,FW_NORMAL,__FONT_NORMAL__);
		draw.DrawStringRect(m_pTxtHelp,&rc,DT_LEFT);
		//::DrawText(hdc,m_pTxtHelp ,wcslen(m_pTxtHelp) ,&rc,DT_LEFT);
		::DeleteObject(m_br);
		::EndPaint(hwnd, &ps);
	
	bHandled = 1;
	return 1;
}
LRESULT CTextEdit::OnMouse(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& bHandled)
{
	if(m_bNoMouse) bHandled=1;
	else bHandled = 0;
	return 0;
}

//===============================================================
//
//  CpssScrollBar 
//
//================================================================
BOOL CpssScrollBar:: CreateWnd(HWND hParentWnd,UINT uId,UINT uidBK, const SCROLL_ITEM *pScrollInfo, int Transdiff)
{
	CRect rtWnd;
	memcpy((void *)&ScrollInfo,(void *)pScrollInfo,sizeof(SCROLL_ITEM));

	
	SetImageTrans(&m_Bitmap[1],uidBK,ScrollInfo.BT_UP, ScrollInfo.BK_rt.left + Transdiff, ScrollInfo.BK_rt.top);
	SetImageTrans(&m_Bitmap_Dn[1],uidBK,ScrollInfo.BT_UP_DN, ScrollInfo.BK_rt.left + Transdiff, ScrollInfo.BK_rt.top);
	SetImageTrans(&m_Bitmap[2],uidBK,ScrollInfo.BT_DW, ScrollInfo.BK_rt.left + Transdiff, ScrollInfo.BK_rt.top + ScrollInfo.BK_rt.bottom - 53);
	SetImageTrans(&m_Bitmap_Dn[2],uidBK,ScrollInfo.BT_DW_DN, ScrollInfo.BK_rt.left + Transdiff, ScrollInfo.BK_rt.top + ScrollInfo.BK_rt.bottom - 53);
	
	
	BITMAP bm;
	if(ScrollInfo.BT_BK)
	{
		//SetImageTrans(&m_Bitmap[0],uidBK,ScrollInfo.BT_BK, ScrollInfo.BK_rt.left + Transdiff, ScrollInfo.BK_rt.top + ScrollInfo.BK_rt.bottom - 53);
		::GetObject(m_Bitmap[1], sizeof(BITMAP), &bm);
		m_rcBK.left = ScrollInfo.BK_rt.left + Transdiff + 4 ;
		m_rcBK.top =  ScrollInfo.BK_rt.top  + bm.bmHeight ;
		SetImageTrans(&m_Bitmap[0],uidBK,ScrollInfo.BT_BK,m_rcBK.left, m_rcBK.top );
		::GetObject(m_Bitmap[0], sizeof(BITMAP), &bm);
		//ScrollInfo.BK_rt.right =  bm.bmWidth;
		//ScrollInfo.BK_rt.bottom = bm.bmHeight;

		m_rcBK.right = m_rcBK.left+ bm.bmWidth ; 
		m_rcBK.bottom = m_rcBK.top + bm.bmHeight ;
		
	}else
	{

	}
	::GetObject(m_Bitmap[1], sizeof(BITMAP), &bm);
	m_Rect[0].left = ScrollInfo.BT_rt.left;
	m_Rect[0].top = ScrollInfo.BT_rt.top;
	m_Rect[0].right =  bm.bmWidth;
	m_Rect[0].bottom = bm.bmHeight;

	::GetObject(m_Bitmap[2], sizeof(BITMAP), &bm);

	m_Rect[1].left = ScrollInfo.BT_rt.left;
	m_Rect[1].top = ScrollInfo.BK_rt.bottom-bm.bmHeight;
	m_Rect[1].right =  bm.bmWidth;
	m_Rect[1].bottom =  bm.bmHeight;


	rtWnd.left=ScrollInfo.BK_rt.left;
	rtWnd.top =ScrollInfo.BK_rt.top;
	rtWnd.right  =rtWnd.left +ScrollInfo.BK_rt.right;
	rtWnd.bottom =rtWnd.top+ScrollInfo.BK_rt.bottom;
	m_rcButton= rtWnd;
	m_rcBK.bottom = m_rcButton.bottom-bm.bmHeight;
	m_rcBK.bottom -= m_rcBK.top;
	SetImageTrans(&m_BitmapDis[0],uidBK,IDB_btn_scrollup_inactive, ScrollInfo.BK_rt.left + Transdiff, ScrollInfo.BK_rt.top);
	SetImageTrans(&m_BitmapDis[1],uidBK,IDB_btn_scrolldown_inactive, ScrollInfo.BK_rt.left + Transdiff, ScrollInfo.BK_rt.top + ScrollInfo.BK_rt.bottom - 53);

	MsgID=uId;
	m_hWnd = hParentWnd;
	return TRUE;
	//DWORD dwStyle = WS_CHILD|WS_VISIBLE|BS_OWNERDRAW|BS_NOTIFY;
	//return (NULL != Create(hParentWnd,rtWnd,0,dwStyle,0,uId));

}

void CpssScrollBar::DrawItem(HDC hDC)
{
	CCanvas canvas(hDC);

/*	if(MenuDC.GetDC())
	{
		RECT rt1,rt2;
		GetWindowRect(&rt1);
		GetParent().GetWindowRect(&rt2);
		canvas.BitBlt(MenuDC.GetDC(),SRCCOPY,lpdis->rcItem,rt1.left-rt2.left,rt1.top-rt2.top);
	}
*/
	
	//draw bar
    canvas.BitBlt(m_Bitmap[0],SRCCOPY,m_rcBK);//canvas.BitBlt(m_Bitmap[0],SRCCOPY,m_rcButton);
	
	CRect re(m_Rect[0]);
	re.OffsetRect(m_rcButton.TopLeft());
	if(m_dwButtonState&1)
		canvas.BitBlt(m_BitmapDis[0],SRCCOPY,re);
	else 
		if (m_nPress == 0 && m_Bitmap_Dn[1].m_hBitmap != NULL) {
			canvas.BitBlt(m_Bitmap_Dn[1],SRCCOPY,re);
		} else {
		canvas.BitBlt(m_Bitmap[1],SRCCOPY,re);
		}
	re = (m_Rect[1]);
	re.OffsetRect(m_rcButton.TopLeft());
	if(m_dwButtonState&2)
		canvas.BitBlt(m_BitmapDis[1],SRCCOPY,re);
	else 
		if (m_nPress == 1 && m_Bitmap_Dn[2].m_hBitmap != NULL) {
			canvas.BitBlt(m_Bitmap_Dn[2],SRCCOPY,re);
		} else {
    canvas.BitBlt(m_Bitmap[2],SRCCOPY,re);
		}

	if( (m_nPress==0 &&  (m_dwButtonState&1) ==0)||  (m_nPress==1 &&(m_dwButtonState&2)==0) )
	{
		//CRect re(m_Rect[m_nPress].left,m_Rect[m_nPress].top,m_Rect[m_nPress].left+m_Rect[m_nPress].right,m_Rect[m_nPress].top+m_Rect[m_nPress].bottom);
		re =(m_Rect[m_nPress]);
		re.OffsetRect(m_rcButton.TopLeft());
		DrawPressedState(hDC, re);
		/*re.bottom-=2; re.right-=2;re.top+=1;re.left+=1;
		 DrawDC  Draw(lpdis->hDC);
		HBRUSH hbr=(HBRUSH) ::SelectObject(lpdis->hDC, GetStockObject(NULL_BRUSH));
		Draw.DrawRoundRect(&re, 3, 0x80FF, 15,14);
		::SelectObject(lpdis->hDC, hbr);*/
	}

    //canvas.BitBlt(m_BackGroundDC->GetDC(),SRCCOPY,CRect(0,0,ScrollInfo.BK_rt.right,ScrollInfo.BK_rt.bottom));
}
LRESULT CpssScrollBar::OnLButtonDown(UINT ctl, CPoint pt)
{
    CRect  rect;
    //CBitmap m_Bmp;
	//m_hOldFocus = SetCapture();
	//HDC hDC=GetDC(m_hWnd);
	//CCanvas canvas(hDC);

	int x = pt.x; 
	int y = pt.y;
	
	if(!m_rcButton.PtInRect(pt) ) return 0;
    
	int bot1 = m_Rect[0].bottom + m_Rect[0].top+ m_rcButton.top;
	int bot2 = m_Rect[1].top + m_rcButton.top;
    if( y<=bot1) 
	{
      //  canvas.BitBlt(m_Bmp.LoadBitmap(ScrollInfo.BT_UP_DN),SRCCOPY,CRect(ScrollInfo.BT_rt.left,ScrollInfo.BT_rt.top,ScrollInfo.BT_rt.right,ScrollInfo.BT_rt.bottom));
	  //  m_Bmp.DeleteObject();
		m_nPress = 0;
// draw a pressed image
	/*	CRect re(ScrollInfo.BT_rt.left,ScrollInfo.BT_rt.top,ScrollInfo.BT_rt.left+ScrollInfo.BT_rt.right,ScrollInfo.BT_rt.top+ScrollInfo.BT_rt.bottom);
		re.bottom-=2; re.right-=2;re.top+=1;re.left+=1;
		 DrawDC  Draw(hDC);
		HBRUSH hbr=(HBRUSH) ::SelectObject(hDC, GetStockObject(NULL_BRUSH));
		Draw.DrawRoundRect(&re, 3, 0x80FF, 15,14);
		::SelectObject(hDC, hbr);*/
		if(m_dwButtonState&1) m_nPress=-1;

	}
	else if(y>bot2 ) //if((x<=ScrollInfo.BT_rt.right)&&(y>=(ScrollInfo.BK_rt.bottom-ScrollInfo.BT_rt.bottom)))
	{
        /*canvas.BitBlt(m_Bmp.LoadBitmap(ScrollInfo.BT_DW_DN),SRCCOPY,
		                               CRect(ScrollInfo.BT_rt.left,ScrollInfo.BK_rt.bottom-ScrollInfo.BT_rt.bottom,
	                                   ScrollInfo.BT_rt.right,ScrollInfo.BT_rt.bottom));
	    m_Bmp.DeleteObject();
		*/
		/*CRect re(ScrollInfo.BT_rt.left,ScrollInfo.BK_rt.bottom-ScrollInfo.BT_rt.bottom,ScrollInfo.BT_rt.left+ScrollInfo.BT_rt.right,
			ScrollInfo.BK_rt.bottom);
		re.bottom-=2; re.right-=2;re.top+=1;re.left+=1;
		 DrawDC  Draw(hDC);
		HBRUSH hbr=(HBRUSH) ::SelectObject(hDC, GetStockObject(NULL_BRUSH));
		Draw.DrawRoundRect(&re, 3, 0x80FF, 15,14);
		::SelectObject(hDC, hbr);*/
		m_nPress = 1;
		if(m_dwButtonState&2) m_nPress=-1;
	}
	if(m_nPress==0||m_nPress ==1) 
	{
		//CRect re(m_Rect[m_nPress].left,m_Rect[m_nPress].top,m_Rect[m_nPress].left+m_Rect[m_nPress].right,m_Rect[m_nPress].top+m_Rect[m_nPress].bottom);
		CRect re(m_Rect[m_nPress]);
		re.right+=re.left;re.bottom+=re.top;
		re.OffsetRect(m_rcButton.TopLeft());
		::PostMessage(m_hWnd,MsgID,m_nPress,0); //::PostMessage(m_hWnd,MsgID,m_nPress,0);
		::InvalidateRect(m_hWnd,&re,1);
		//::UpdateWindow(m_hWnd);
		m_nTimer = ::SetTimer(m_hWnd, 0x71,150,NULL);
	}	
	return 1;
}

void CpssScrollBar::OnTimer(WPARAM wParam)
{
	if(m_nTimer==wParam)
		if(m_nPress==0||m_nPress ==1) ::PostMessage(m_hWnd,MsgID,m_nPress,0); 
	
}
LRESULT CpssScrollBar::OnLButtonUp(UINT ctl, CPoint pt)
{
	int x = pt.x; 
	int y = pt.y;
	//::SetCapture(NULL);
	if(m_nTimer!=-1) ::KillTimer(m_hWnd,m_nTimer);m_nTimer=-1;
	if(	m_nPress !=-1){
		//CRect re(m_Rect[m_nPress].left,m_Rect[m_nPress].top,m_Rect[m_nPress].left+m_Rect[m_nPress].right,m_Rect[m_nPress].top+m_Rect[m_nPress].bottom);
		CRect re(m_Rect[m_nPress]);
		re.right+=re.left;re.bottom+=re.top;
		re.OffsetRect(m_rcButton.TopLeft());



		m_nPress = -1;
		::InvalidateRect(m_hWnd,&re,1);
		//::UpdateWindow(m_hWnd);

	}
	if(m_rcButton.PtInRect(pt)) return 1;
	//bHandled = 1;
	return 0;
}

void CSliderButton::DrawItem(HDC hDC)
{
	int err=0;
//	CCanvas canvas(hDC);
	BOOL b = 0;
	HBITMAP hbitmap=m_Bitmap[0];
#if 0
	CRect rt(m_rcButton);
	CRect rc(m_rcBack);
	rc.right = ( rt.left+rt.right)/2-m_rcBack.left ;
	rc.bottom-=rc.top;
	canvas.BitBlt(m_Bitmap[1],rc.left,rc.top);
	

	int x = (rt.left+rt.right)/2-m_rcBack.left ; 
	rc.left =  (rt.left+rt.right)/2 ;
	rc.right=m_rcBack.Width()-x;
	//rc.bottom-=rc.top; rc.top=0;
	canvas.BitBlt(m_Bitmap[2],SRCCOPY,rc,x,0);

	rc = m_rcButton;
	rc.bottom-=rc.top;rc.right-=rc.left;

	canvas.BitBlt(m_Bitmap[0],rc.left,rc.top);
#else
	if(m_bShow && hbitmap)
	{
		//CClientDC clientDC ( GetParent());
		int width = m_rcBack.Width();
		int height = m_rcBack.Height();
		CRect	 rt(0,0,width,height);
		//GetWindowRect(&rt2);
		CDC memDC = CreateCompatibleDC(hDC);
		CBitmap myBmp = CreateCompatibleBitmap(hDC,m_rcBack.Width(),m_rcBack.Height());
		if(!myBmp)
		{
			err = GetLastError();
			return ;
		}
		HBITMAP hOldBmp = memDC.SelectBitmap(myBmp);

		memDC.FillSolidRect(&rt,RGB(0,128,128));
		CCanvas vCanvas(memDC);
		if(m_Bitmap[2])
		{
			rt = (m_rcButton);
			width = ( rt.left+rt.right)/2-m_rcBack.left ;
		}
		//rc.right-=rc.left;rc.bottom-=rc.top;
		CRect rc(0,0,width,height);	
		vCanvas.BitBlt(m_Bitmap[1],SRCCOPY,rc);
		
		if(m_Bitmap[2])
		{
			rc = (m_rcBack);
			int x = (rt.left+rt.right)/2 -m_rcBack.left ; 
			rc.left =  x ;
			rc.right=m_rcBack.Width()-rc.left;
			rc.bottom-=rc.top; rc.top=0;
			vCanvas.BitBlt(m_Bitmap[2],SRCCOPY,rc,x,0);
		}
		rc.SetRect(m_rcButton.left-m_rcBack.left,0,m_rcButton.Width(),m_rcButton.Height());

		vCanvas.BitBlt(m_Bitmap[0],SRCCOPY,rc);
		
		//SaveBitmap(L"ScrnStart.bmp",myBmp);
		//canvas.BitBlt(myBmp,m_rcBack.left,m_rcBack.top);
		//BitBlt(hDC , m_rcBack.left,m_rcBack.top, m_rcBack.Width(),m_rcBack.Height(),memDC,0,0,SRCCOPY);
	    b =::TransparentBlt(hDC, m_rcBack.left,m_rcBack.top ,m_rcBack.Width(),m_rcBack.Height(),memDC,\
			0,0,m_rcBack.Width(),m_rcBack.Height(), RGB(0,128,128));
		//b =::BitBlt(hDC, m_rcBack.left,m_rcBack.top ,m_rcBack.Width(),m_rcBack.Height(),memDC,\
		//	0,0,SRCCOPY);
		//canvas.BitBlt(m_Bitmap[1],m_rcBack.left,m_rcBack.top);
		//CBitmap myBmp(m_bmpBk);
		//SaveBitmap(L"ScrnStart.bmp",myBmp);

		//clientDC.BitBlt ( 0,0,rt2.Width(), rt2.Height() , m_dcBk,0,0,SRCCOPY);

		//canvas.BitBlt(m_bmpBk,SRCCOPY,lpdis->rcItem ,rt.left,rt.top);
		/*if(MenuDC.GetDC())
		{
			RECT rt1,rt2;
			GetWindowRect(&rt1);
			GetParent().GetWindowRect(&rt2);
			canvas.BitBlt(MenuDC.GetDC(),SRCCOPY,lpdis->rcItem,rt1.left-rt2.left,rt1.top-rt2.top);
		}*/
		//canvas.BitBlt(hbitmap,SRCCOPY,lpdis->rcItem);
		hOldBmp = memDC.SelectBitmap(hOldBmp);
		if(!myBmp.DeleteObject())
			err = GetLastError();
		if(!memDC.DeleteDC())
			err = GetLastError();
	}else
	{
		// draw a pressed image
	//	CRect re(lpdis->rcItem);
	//	DrawPressedState(lpdis->hDC, re);
		/*re.bottom-=2; re.right-=2;re.top+=1;re.left+=1;
		 DrawDC  Draw(lpdis->hDC);
		HBRUSH hbr=(HBRUSH) ::SelectObject(lpdis->hDC, GetStockObject(NULL_BRUSH));
		Draw.DrawRoundRect(&re, 3, 0x80FF, 15,14);
		::SelectObject(lpdis->hDC, hbr);*/
	}
#endif
}
LRESULT CSliderButton::OnMouseMove(UINT, CPoint pt)
{
	//UINT nFlags, CPoint point;
//	CTrackBarCtrl::OnMouseMove(nFlags, point);
//	CPoint  pt(GET_X_LPARAM(lParam),GET_Y_LPARAM(lParam));
	CPoint oldpt;
	if (m_IsDragging)
	{
		CRect rc;
		//ClientToScreen(&pt);
		int cx = pt.x-m_pt.x;
		//GetWindowRect(&rc);
		rc = m_rcButton;
		oldpt = m_pt;
		m_pt.x = pt.x;
		int s = rc.left+cx;

		//if( s< m_rcBack.left || s > m_rcBack.right-m_rcButton.Width())cx=0;

		::InvalidateRect(m_hWnd,&m_rcButton,0);
		if( s< m_rcBack.left )
		{
			m_rcButton.MoveToX( m_rcBack.left);
		}else if( s > m_rcBack.right-m_rcButton.Width())
			m_rcButton.MoveToX(m_rcBack.right-m_rcButton.Width());
		else m_rcButton.OffsetRect( cx, 0);
		::InvalidateRect(m_hWnd,&m_rcButton,0);
		
		
		//if(cx!=00)
		{
			CRect rt(m_rcBack);
			rc.left = min( oldpt.x- m_rcButton.Width() , m_rcButton.left  );
			rc.right= max( oldpt.x+ m_rcButton.Width() , m_rcButton.right  );
			
			::InvalidateRect(m_hWnd,&rc,0);
		
		}
		UpdateWindow(m_hWnd);
		return 1;
	}
	return 0;
}

// When reporting slider position, we also indicate if it is being dragged by the mouse
LRESULT CSliderButton::OnLButtonDown(UINT, CPoint pt)
{
	// TODO: Add your message handler code here and/or call default

	if(m_rcButton.PtInRect(pt))
	{
		m_IsDragging = TRUE;
		m_pt = pt;
	}else if(m_type==1 && m_rcBack.PtInRect(pt))
	{
		if(m_rcBack.right-pt.x<m_rcButton.Width())
			pt.x = m_rcBack.right - m_rcButton.Width();
		m_rcButton.MoveToX( pt.x);
		::InvalidateRect(m_hWnd,&m_rcBack,0);
		return 1;
	}
//	m_pt.x = GET_X_LPARAM(lParam);
//	m_pt.y = GET_Y_LPARAM(lParam);
//	ClientToScreen(&m_pt);
	//CSliderCtrl::OnLButtonDown(nFlags, point);
//	bHandled = 0;
	return 0;
}

LRESULT CSliderButton::OnLButtonUp(UINT, CPoint pt)
{
	// TODO: Add your message handler code here and/or call default

//	bHandled = 0;
	if(m_type==0)
	{
		if(m_IsDragging) //if(m_rcButton.PtInRect(pt))
		{
			int spd = GetSpeed();
			//SendMessage(m_hWnd,WM_SPEED_CHANGE,0,(LPARAM)spd );
		}else if(!m_IsDragging && m_rcBack.PtInRect(pt) )
			return 5;
	}else 
	{
		if(!m_IsDragging && m_rcBack.PtInRect(pt) ) return 5;
	}
	m_IsDragging = FALSE;
	return 0;
}
/*
void CProgressCtrlX::DrawItem(LPDRAWITEMSTRUCT lpdis)
{
	CCanvas canvas(lpdis->hDC);


	HBITMAP hbitmap = (0 != (lpdis->itemState & ODS_SELECTED)) 
					  ? m_Bitmap[1] : m_Bitmap[0];
	if(MenuDC.GetDC())
	{
		RECT rt1,rt2;
		GetWindowRect(&rt1);
		GetParent().GetWindowRect(&rt2);
		canvas.BitBlt(MenuDC.GetDC(),SRCCOPY,lpdis->rcItem,rt1.left-rt2.left,rt1.top-rt2.top);
	}
	canvas.BitBlt(hbitmap,SRCCOPY,lpdis->rcItem);
}*/
static HWND g_hPrevHwnd = NULL;
void __set_pre_window_handle__(HWND hwnd)
{
#ifdef UNDER_CE
	CRegKey rkey;
	int result;
	result = rkey.Open(HKEY_CURRENT_USER,TEXT("\\ControlPanel\\cpss\\Current"));
	if (ERROR_SUCCESS != result)
	{
		rkey.Create(HKEY_CURRENT_USER,TEXT("\\ControlPanel\\cpss\\Current"));
		g_hPrevHwnd = NULL;
	}else  rkey.QueryDWORDValue(  TEXT("Window"), (DWORD& )g_hPrevHwnd);

	rkey.SetDWORDValue(TEXT("Window"),(DWORD) hwnd);
#endif
}

void __restore_pre_window_handle__(HWND hwnd)
{
#ifdef UNDER_CE
	CRegKey rkey;
	int result;
	if(hwnd!= g_hPrevHwnd)
	{
		result = rkey.Open(HKEY_CURRENT_USER,TEXT("\\ControlPanel\\cpss\\Current"));
		if (ERROR_SUCCESS != result)
		{
			rkey.Create(HKEY_CURRENT_USER,TEXT("\\ControlPanel\\cpss\\Current"));
		}
		rkey.SetDWORDValue(TEXT("Window"),(DWORD) g_hPrevHwnd);
	}
#endif
}
#ifdef UNDER_CE

#ifdef __MYFLASHDISK__

typedef HBITMAP (*cfunc)(LPVOID pBuf,unsigned long size, int mode);
static cfunc LoadPng=NULL;
extern BOOL g_bHasImaging;

HBITMAP SHLoadImageResource2 (HINSTANCE obj,  UINT res )
{
      //char mod(20);
      int size;
      HANDLE hRes;
      LPVOID pBuf=0;
     // TCHAR szBuf[256];
	  obj = GetSkinHandle();
      if ( LoadPng == NULL){
            HMODULE hm = LoadLibrary(__FLASHDISK_W_ L"\\PNG_Import");
            LoadPng=(cfunc)GetProcAddress(hm, TEXT("LoadPng"));
          
      }
      HRSRC  hRsrc = FindResource(obj ,MAKEINTRESOURCE(res),TEXT("PNG") );
      if(hRsrc){
            size = SizeofResource(obj,hRsrc);
            hRes = LoadResource(obj, hRsrc);
            pBuf = LockResource(hRes);
      }
      //int ts=GetTickCount();
	  if(pBuf)
	  {
		  HBITMAP hh=LoadPng(pBuf,size,1);
		  if(hRes) 
		  {  FreeResource(hRes);
		  }
		  return hh;
	  }else return NULL;
	
}
#endif

#include <imaging.h>
#if (_WIN32_WCE < 0x700)  && !defined(__PHOTO__) // jerry
#ifndef ___IMAGING_DEF__
#undef DEFINE_GUID
#define DEFINE_GUID(name, l, w1, w2, b1, b2, b3, b4, b5, b6, b7, b8) \
        EXTERN_C const GUID name \
                = { l, w1, w2, { b1, b2,  b3,  b4,  b5,  b6,  b7,  b8 } }
			
DEFINE_GUID(IID_IImagingFactory, 0x327abda7,0x072b,0x11d3,0x9d,0x7b,0x00,0x00,0xf8,0x1e,0xf3,0x2e);
DEFINE_GUID(CLSID_ImagingFactory, 0x327abda8,0x072b,0x11d3,0x9d,0x7b,0x00,0x00,0xf8,0x1e,0xf3,0x2e);
#endif
#endif


HBITMAP SHLoadImageFile (
  LPCTSTR pszFileName
)
{
    IImagingFactory *pImgFactory = NULL;
    IImage *pImage = NULL;
    CoInitializeEx(NULL, COINIT_MULTITHREADED);
    HBITMAP hResult = 0;
    if (SUCCEEDED(CoCreateInstance (CLSID_ImagingFactory,
                                    NULL,
                                    CLSCTX_INPROC_SERVER,
                                    IID_IImagingFactory,
                                    (void **)&pImgFactory)))
    {
      ImageInfo imageInfo;
        if (SUCCEEDED(pImgFactory->CreateImageFromFile(pszFileName, &pImage))
         && SUCCEEDED(pImage->GetImageInfo(&imageInfo)))
        {
         CWindowDC dc(0);
         CDC dcBitmap;
         dcBitmap.CreateCompatibleDC(dc.m_hDC);
         hResult = CreateCompatibleBitmap(dc.m_hDC, imageInfo.Width, imageInfo.Height);
         if (hResult) {
            HGDIOBJ hOldBitmap = SelectObject(dcBitmap.m_hDC, hResult);
              pImage->Draw(dcBitmap.m_hDC, CRect(0, 0, imageInfo.Width, imageInfo.Height), NULL);
            SelectObject(dcBitmap.m_hDC,hOldBitmap);
         }
         pImage->Release();
        }
        pImgFactory->Release();
    }
    CoUninitialize();

   return hResult; 
	
}

#include <map>
static HINSTANCE hMenuRes = NULL;
std::map<int,int> gResMap;

HRSRC LoadSecondRes(int resID)
{
	if(!hMenuRes)
	{
		hMenuRes = LoadLibrary(SKIN_PATH L"\\cpss_menu_res_1.dll");
		gResMap[201] = 413;
		gResMap[221] = 4101;
		gResMap[223] = 4103;
		gResMap[227] = 6227;
 
		gResMap[461] = 6461;
		gResMap[668] = 3517;
		gResMap[669] = 3519;
		gResMap[670] = 3521;
 
		gResMap[205] = 411;
		gResMap[211] = 923;
		gResMap[213] = 4109;
		gResMap[215] = 4117;
 
 		gResMap[217] = 4119;
		gResMap[219] = 4107;
		gResMap[233] = 6233;
		gResMap[4113] = 4113;
 
 
		 gResMap[261] = 6261;
		gResMap[305] = 4111;
		gResMap[453] = 4124;
		gResMap[455] = 4122;
	
		gResMap[501] = 3120;
		gResMap[528] = 6528;
		gResMap[661] = 3530;
		gResMap[662] = 3531;
 
		gResMap[929] = 929;
		gResMap[939] = 3118;
		gResMap[940] = 3116;
		gResMap[1006] = 3121;

	}
	//if(gResMap.find(resID)
	int newID = gResMap[resID];
	if(newID==0) return NULL;
	HRSRC hRsrc = FindResource(hMenuRes ,MAKEINTRESOURCE(newID),TEXT("JPG") );
	return hRsrc;
}

HBITMAP SHLoadImageResource (HINSTANCE hInst,  UINT resID )
{
#ifdef __MYFLASHDISK__
	if(!g_bHasImaging)
	{	
		return SHLoadImageResource2 (hInst, resID );
	}
#endif
	
	IImagingFactory *pImgFactory = NULL;
    IImage *pImage = NULL;
 //   CoInitializeEx(NULL, COINIT_MULTITHREADED);
    HBITMAP hResult = 0;
	HANDLE hRes=0;

    if (SUCCEEDED(CoCreateInstance (CLSID_ImagingFactory,
                                    NULL,
                                    CLSCTX_INPROC_SERVER,
                                    IID_IImagingFactory,
                                    (void **)&pImgFactory)))
    {
      ImageInfo imageInfo;
	  LPVOID pBuf=0;
	  HRSRC hRsrc=0;

	  
	  if(hInst==NULL) hInst = GetSkinHandle();
	  hRsrc = FindResource(hInst ,MAKEINTRESOURCE(resID),TEXT("PNG") );
	  if(!hRsrc){
		  hRsrc = LoadSecondRes(resID);
		  hInst = hMenuRes;
	  }
	  if(hRsrc){
		hRes = LoadResource(hInst, hRsrc);
		pBuf = LockResource(hRes);
	  }
	  if(!pBuf) return 0;
        if (SUCCEEDED(pImgFactory->CreateImageFromBuffer(pBuf,SizeofResource(hInst,hRsrc),
			  BufferDisposalFlagNone ,&pImage))
         && SUCCEEDED(pImage->GetImageInfo(&imageInfo)))
        {
         CWindowDC dc(0);
         CDC dcBitmap;
         dcBitmap.CreateCompatibleDC(dc.m_hDC);
         hResult = CreateCompatibleBitmap(dc.m_hDC, imageInfo.Width, imageInfo.Height);
         if (hResult) {
            HGDIOBJ hOldBitmap = SelectObject(dcBitmap.m_hDC,hResult);
              pImage->Draw(dcBitmap.m_hDC, CRect(0, 0, imageInfo.Width, imageInfo.Height), NULL);
            SelectObject(dcBitmap.m_hDC,hOldBitmap);
         }
         pImage->Release();
        }
        pImgFactory->Release();
    }
 //   CoUninitialize();
	if(hRes) {
		FreeResource(hRes);
	}

	return hResult;
	
}
//#endif

#else
HBITMAP SHLoadImageFile (
  LPCTSTR pszFileName
)
{
  
   return NULL; 
	
}
HBITMAP SHLoadImageResource (HINSTANCE hInst,  UINT resID )
{
	return NULL;
}
#endif


BOOL SystemTimeToTzSpecificLocalTime(LPTIME_ZONE_INFORMATION lpTimeZone,LPSYSTEMTIME lpUniversalTime,LPSYSTEMTIME lpLocalTime)  
{  
	TIME_ZONE_INFORMATION TZ;
		lpTimeZone = &TZ;
	int ret=	GetTimeZoneInformation(lpTimeZone);//TIME_ZONE_ID_STANDARD

	if(lpTimeZone == NULL || lpUniversalTime == NULL || lpLocalTime == NULL)  
	 {  
	  //ָΪգûбҪκμ   
	  return FALSE;  
	 }  
	  
	 //UTCʱSYSTEMTIMEתΪFILETIMEʽ   
	 FILETIME ftUniversalTime = {0};  
	 SystemTimeToFileTime(lpUniversalTime,&ftUniversalTime);  
	  
	 //FILETIMEʽʱֵ洢һDWORD64   
	 DWORD64 ddwUniversalTime = ftUniversalTime.dwHighDateTime;  
	 ddwUniversalTime = ddwUniversalTime << 32;  
	 ddwUniversalTime += ftUniversalTime.dwLowDateTime;  
	  
	  
	 //ΪFILETIMEʱ䵥λ100ڷ֮һ룬ȻTIME_ZONE_INFORMATIONʱ䵥λǷ֣Ҫ600000000    
	 DWORD64 ddwBias = abs(lpTimeZone->Bias);   
	 ddwBias *= 600000000;  
	  
	 
	 //תʽΪLOCAL_TIME = UTC - BIAS   
	 DWORD64 ddwLocalTime = 0;  
	 if(lpTimeZone->Bias > 0)  
	 {    
	  ddwLocalTime = ddwUniversalTime - ddwBias;  
	 }  
	 else if(lpTimeZone->Bias < 0)  
	 {  
	  ddwLocalTime = ddwUniversalTime + ddwBias;  
	 }  

	 if(ret==TIME_ZONE_ID_DAYLIGHT)
	 {
	 DWORD64 ddwDSTBias = abs(lpTimeZone->DaylightBias);   
	 ddwDSTBias *= 600000000;  
	  
	 
	 //תʽΪLOCAL_TIME = UTC - BIAS   
	  
	 if(lpTimeZone->DaylightBias > 0)  
	 {    
	  ddwLocalTime = ddwLocalTime - ddwDSTBias;  
	 }  
	 else if(lpTimeZone->DaylightBias < 0)  
	 {  
	  ddwLocalTime = ddwLocalTime + ddwDSTBias;  
	 }  
	 }
	
	//DWORD64ֵתΪFILETIMEʽ   
	 FILETIME ftLocalTime = {0};  
	 ftLocalTime.dwLowDateTime = static_cast<DWORD>(ddwLocalTime);  
	 ftLocalTime.dwHighDateTime = static_cast<DWORD>(ddwLocalTime >> 32);  
	    
	 //FILETIMEֵתΪSYSTEMTIMEʽ   
	 return FileTimeToSystemTime(&ftLocalTime,lpLocalTime);  
	  
 
} 
TCHAR* utf8ToUnicode(char* str) 
{ 
    //UTF8 to Unicode
     size_t wcsLen = ::MultiByteToWideChar(CP_UTF8, NULL, str, strlen(str), NULL, 0);
 
    //ռҪ''ռ䣬MultiByteToWideChar''ռ
     wchar_t* wszString =(wchar_t*) malloc( 2*(wcsLen + 1));
     memset(wszString, 0, sizeof(wchar_t)*(wcsLen + 1));
     //ת
     ::MultiByteToWideChar(CP_UTF8, NULL, str, strlen(str), wszString, wcsLen);
     TCHAR* wstr= wszString;
     //delete wszString;
	 free(str);
     return wstr;
 
}
TCHAR* read_file(FILE * fin)
{
	fseek(fin,0,SEEK_END);
	long l = ftell(fin);
	fseek(fin,0,SEEK_SET);
	TCHAR* tmp = (wchar_t*) malloc(2*l+2);
	memset(tmp,0,2*l+2);
	TCHAR* pText=tmp;
	fread((wchar_t *)tmp,1, l,fin);
	fclose(fin);
	
	if(tmp[0]==0xBBEF )
	{
		pText= utf8ToUnicode((char*)tmp);
		tmp = pText;
	}else if(tmp[0]==0xFEFF ) pText=tmp;
	else {		 
		char * asc =(char*) malloc(2*l+2);
		strcpy(asc, (char*) tmp) ;
		mbstowcs( tmp, asc,strlen(asc)+1);
		pText = tmp;
		free(asc);
	}
	return pText;
}
BOOL CALLBACK  EnumCallback(HWND hWnd, LPARAM lParam)
{
	SendMessage(hWnd,WM_USER_CHANGE_SKIN,0,1);
	return TRUE;
}
#if 0
void CEditButton::DrawItem(LPDRAWITEMSTRUCT lpdis)
{
	CCanvas canvas(lpdis->hDC);

	if(MenuDC.GetDC())
	{
		RECT rt1,rt2;
		GetWindowRect(&rt1);
		GetParent().GetWindowRect(&rt2);
		canvas.BitBlt(MenuDC.GetDC(),SRCCOPY,lpdis->rcItem,rt1.left-rt2.left,rt1.top-rt2.top);
	}

	if(!m_Bitmap[0].IsNull() && !m_Bitmap[1].IsNull())
	{
		if (TRUE == m_focus)
		{
			canvas.BitBlt(m_Bitmap[0],SRCCOPY,lpdis->rcItem);
		}
		else
		{
			HBITMAP hbitmap = (0 != (lpdis->itemState & ODS_SELECTED)) 
				? m_Bitmap[0] : m_Bitmap[1];
			canvas.BitBlt(hbitmap,SRCCOPY,lpdis->rcItem);
		}
	}
	else
	{
		DrawDC Draw(lpdis->hDC);
		Draw.DrawFillRoundRect(&m_TextRect,RGB(0x6E,0x6E,0x70),10,10);
		Draw.DrawFillRoundRect(CRect(m_TextRect.left+1,m_TextRect.top+1,m_TextRect.right,m_TextRect.bottom),RGB(0xA4,0xA5,0xA9),10,10);
		Draw.DrawFillRoundRect(CRect(m_TextRect.left+1,m_TextRect.top+1,m_TextRect.right-1,m_TextRect.bottom-1),RGB(255,255,255),10,10);

	
	}

	BkModeHold bkmode(canvas,TRANSPARENT);
	UserFont userfont(canvas,m_TextSize,FW_BOLD);
	ObjHold<HFONT> fonthold(canvas,userfont);
/*
	CRect rtitem = lpdis->rcItem;
	rtitem.right += rtitem.left;
	rtitem.bottom += rtitem.top;
*/	
	if(m_pwdtype)
	{
		LPTSTR str;
		str=new WCHAR[m_str.GetLength()+1];
		for(int i=0;i<m_str.GetLength();i++)
			str[i]=0x002a;//_T("*");
		str[m_str.GetLength()]=0;
		canvas.DrawText(str,m_TextRect,m_TextFormat);
		delete[] str;
		
	}
	else
	{
		canvas.DrawText(m_str,m_TextRect,m_TextFormat);
	}
}
#endif




char g_deviceId[8]="600000";
//typedef BOOL (*P_MISC_Read_Raw_Flash)(DWORD sect, LPBYTE pBuf, DWORD numSects,LPBYTE pSectInfo );
BOOL get_device_id(char * deviceId)
{
	BOOL bOK =TRUE;
	strcpy(deviceId, g_deviceId);
	return bOK;
}

#pragma once
#include <wincrypt.h>
class PocketGuid
{
private:
    // One to three bits of the clock sequence section are used to define the variant, or layout, 
    // of the GUID. Windows and the PocketGuid class generate variant type 2 GUIDs.
    enum GuidVariant
    {
        ReservedNCS = 0x00,
        Standard = 0x02,
        ReservedMicrosoft = 0x06,
        ReservedFuture = 0x07
    };
    // The upper four bits of the timestamp section contain the GUID's version that specifies the content of 
    // each section. Before Windows 2000, the CoCreateGuid function generated version 1 GUIDs. With Windows 2000, 
    // Microsoft switched to version 4 GUIDs, since embedding the MAC address was viewed as a security risk. 
    // The PocketGuid class also generates version 4 GUIDs.
    enum GuidVersion
    {
        TimeBased = 0x01,
        Reserved = 0x02,
        NameBased = 0x03,
        Random = 0x04
    };
    class Const
    {
        // number of bytes in guid
    public:
        static const int ByteArraySize = 16;
  
  // multiplex variant info
  static const int VariantByte = 8;
  static const int VariantByteMask = 0x3f;
  static const int VariantByteShift = 6;
  // multiplex version info
  static const int VersionByte = 7;
  static const int VersionByteMask = 0x0f;
  static const int VersionByteShift = 4;
    };
public:
    static HRESULT CreateGuid (GUID & guid)
    {
        HCRYPTPROV hCryptProv = NULL;
        HRESULT hr = S_OK;
  
        // holds random bits for guid
        BYTE  * bits = new BYTE[Const::ByteArraySize];
        if (bits == NULL)
        {
            hr = E_OUTOFMEMORY;
            goto ExitHere;
        }
        // get crypto provider handle
        if (!CryptAcquireContext (&hCryptProv, NULL, NULL, PROV_RSA_FULL, CRYPT_VERIFYCONTEXT))
        {
            hr = HRESULT_FROM_WIN32 (GetLastError ());
            goto ExitHere;
        }
        // generate a 128 bit (16 byte) cryptographically random number
        if (!CryptGenRandom (hCryptProv, Const::ByteArraySize, bits))
        {
            hr = HRESULT_FROM_WIN32 (GetLastError ());
            goto ExitHere;
        }
        // set the variant
        bits[Const::VariantByte] &= Const::VariantByteMask;
        bits[Const::VariantByte] |= ((int)Standard << Const::VariantByteShift);
        // set the version
        bits[Const::VersionByte] &= Const::VersionByteMask;
        bits[Const::VersionByte] |= ((int)Random << Const::VersionByteShift);        
        
        memcpy (&guid, bits, sizeof (GUID));
   
    ExitHere:
        if (hCryptProv != NULL)
            CryptReleaseContext (hCryptProv, 0);
        if (bits != NULL)
            delete [] bits;
  return hr;
    };
};


HRESULT CreateUUID(GUID & guid)
{
	return PocketGuid::CreateGuid (guid);
}

void fire_wakeup_event()
{
	HANDLE h = CreateEvent(NULL,FALSE,FALSE,L"DEVICE.WAKEUP");
	SetEvent(h);
	CloseHandle(h);
	h = CreateEvent(NULL,FALSE,FALSE,L"system_activity");
	SetEvent(h);
	CloseHandle(h);
}

void EnableSIP(int en)
{
//[HKEY_CURRENT_USER\ControlPanel\SIP]
//"TurnOffAutoDeploy"=dword:1


#ifdef UNDER_CE
	CRegKey rkey;
	int result;
	result = rkey.Open(HKEY_CURRENT_USER,TEXT("\\ControlPanel\\SIP"));
	if (ERROR_SUCCESS != result)
	{
		rkey.Create(HKEY_CURRENT_USER,TEXT("\\ControlPanel\\SIP"));
		
	}
	rkey.SetDWORDValue(TEXT("TurnOffAutoDeploy"),(DWORD)en?0:1);
#endif
}

static void Mix(BYTE ** FRNT, BYTE * BACK, int x, int y, int width, int height,int wBK=SCREEN_W,int hBK=SCREEN_H) 
{
        int bytes = width * height * 4;
        int j;
        //try
        {
            int zz = 0;
            int yy = 0;
            int pixelinzeile = 0;
            int zeile = 0;
            for (j = 0; j <= (bytes) - 4; j += 4)
            {
                int a, r, g, b, rm, gm, bm, rn, gn, bn;
                int proz = 0;
                a = (int) *((*FRNT) + j + 3);
                zz++;
                if (a != 255)
                {
                    yy++;
                    proz = ((int)a) * 100 / 255;

			        b = (int) *((*FRNT) + j);
		            g = (int) *((*FRNT) + j + 1);
	                r = (int) *((*FRNT) + j + 2);


                    int pixel = (((hBK - y) - (height - zeile)) * wBK + pixelinzeile + x)*4;
                    bm = BACK[pixel];
                    gm = BACK[pixel + 1];
                    rm = BACK[pixel + 2];

                    rn = (int)(((100 - proz) * rm + proz * r) / 100);
                    gn = (int)(((100 - proz) * gm + proz * g) / 100);
                    bn = (int)(((100 - proz) * bm + proz * b) / 100);


					*((*FRNT)+j) = (byte) bn;
					*((*FRNT)+j + 1) = (byte) gn;
					*((*FRNT)+j + 2) = (byte) rn;

                }
                pixelinzeile++;
                if (pixelinzeile == width)
                {
                    zeile++;
                    pixelinzeile = 0;
                }
            }
        }
       // catch (...)
        {
            
        }
}
/*
static void Mix(BYTE ** FRNT, BYTE * BACK, int x, int y, int width, int height) 
{
        int bytes = width * height * 4;
        int j;
        //try
        {
            int zz = 0;
            int yy = 0;
            int pixelinzeile = 0;
            int zeile = 0;
            for (j = 0; j <= (bytes) - 4; j += 4)
            {
                int a, r, g, b, rm, gm, bm, rn, gn, bn;
                int proz = 0;
                a = (int) *((*FRNT) + j + 3);
                zz++;
                if (a != 255)
                {
                    yy++;
                    proz = ((int)a) * 100 / 255;

			        b = (int) *((*FRNT) + j);
		            g = (int) *((*FRNT) + j + 1);
	                r = (int) *((*FRNT) + j + 2);


                    int pixel = (((480 - y) - (height - zeile)) * 800 + pixelinzeile + x)*4;
                    bm = BACK[pixel];
                    gm = BACK[pixel + 1];
                    rm = BACK[pixel + 2];

                    rn = (int)(((100 - proz) * rm + proz * r) / 100);
                    gn = (int)(((100 - proz) * gm + proz * g) / 100);
                    bn = (int)(((100 - proz) * bm + proz * b) / 100);


					*((*FRNT)+j) = (byte) bn;
					*((*FRNT)+j + 1) = (byte) gn;
					*((*FRNT)+j + 2) = (byte) rn;

                }
                pixelinzeile++;
                if (pixelinzeile == width)
                {
                    zeile++;
                    pixelinzeile = 0;
                }
            }
        }
       // catch (...)
        {
            
        }
}*/
 HBITMAP LoadIPNImage(UINT res, BYTE ** pbuf, int * width, int * height, BOOL WithImage) {
			HMODULE hModule = GetModuleHandle(NULL); // get the handle to the current module (the executable file)
			HRSRC hResource = FindResource(hModule, MAKEINTRESOURCE(res), TEXT("BINARY")); // substitute RESOURCE_ID and RESOURCE_TYPE.
			if(hResource==0)
			{
				hModule = GetSkinHandle(); // get the handle to the current module (the executable file)
				hResource = FindResource(hModule, MAKEINTRESOURCE(res), TEXT("BINARY")); // substitute RESOURCE_ID and RESOURCE_TYPE.
				if (hResource == 0) {
					return 0;
				}
			}
			HGLOBAL hMemory = LoadResource(hModule, hResource);
			DWORD dwSize = SizeofResource(hModule, hResource);
			LPVOID lpAddress = LockResource(hMemory);
			//Entpacken
			byte *unc = new byte[dwSize];
			memcpy(unc, lpAddress, dwSize);
			
            *width = unc[0] * 255 + unc[1];
            *height = unc[2] * 255 + unc[3];
            int lcolors = unc[4] * 255 + unc[5];


			//In Array schreiben
			byte * bts = new byte [*width * *height * 4];
            int offset = 10 + 4 * lcolors;
            int px = 0;
            //Zeichnen
            int state = 1;
            int AnzahlColor = 0;
            int ColIndex = 0;
            int AnzahlAnzahl = 0;

            for (int y = offset; (DWORD) y < dwSize; y++)
            {
                uint bt = unc[y];
                if (state == 1)
                {
                    AnzahlAnzahl = 1;
                    //Anzahl
                    if ((bt & 128) == 128)
                    {
                        AnzahlColor = (AnzahlColor + (bt - 128)) * 31;
                    }
                    else
                    {
                        if ((bt & 64) == 0)
                        {
                            AnzahlColor += bt;
                            ColIndex = 0;
                            state = 2;
                        }
                        else
                        {
                            state = 2;
                            AnzahlAnzahl = bt - 64;
                            AnzahlColor = 1;
                            if ((bt & 32) == 32)
                            {
                                AnzahlAnzahl -= 32;
                                AnzahlColor = 2;
                            }
                        }

                    }
                }
                else if (state == 2)
                {
                    if ((bt & 128) == 128)
                    {
                        ColIndex = (ColIndex + (bt - 128)) * 127;
						if (ColIndex <0) {
						}
                    }
                    else
                    {
                        ColIndex += bt;
                        for (int ot = 0; ot < AnzahlColor; ot++)
                        {
							/*wchar_t text [100];
							wsprintf(text,TEXT("Daten: %d %d %d %d\r\n"),width * height * 4,px, ColIndex,10 + ColIndex * 4 + 3 );
							OutputDebugString(text);*/
							try {
								bts[px++] = unc[10 + ColIndex * 4 + 3];
								bts[px++] = unc[10 + ColIndex * 4 + 2];
								bts[px++] = unc[10 + ColIndex * 4 + 1];
								bts[px++] = unc[10 + ColIndex * 4 + 0];
							} catch (...)
							{
								OutputDebugString(TEXT("ERROR\r\n"));
							}
                        }
                        ColIndex = 0;
                        if (AnzahlAnzahl == 1)
                        {
                            state = 1;
                            AnzahlColor = 0;
                        }
                        AnzahlAnzahl--;
                    }
                }
            }
			HBITMAP m_hbitmap = 0;
			//Leeres Bild erstellen
			BITMAPINFO	bitmapinfo	= {0};
			*pbuf		= NULL;

			bitmapinfo.bmiHeader.biSize		= sizeof(BITMAPINFOHEADER);
			bitmapinfo.bmiHeader.biWidth	= *width;
			bitmapinfo.bmiHeader.biHeight	= *height;
			bitmapinfo.bmiHeader.biPlanes	= 1;
			bitmapinfo.bmiHeader.biBitCount = 32;
			bitmapinfo.bmiHeader.biCompression = BI_RGB;
			HDC hdc = GetDC(0);
			m_hbitmap = ::CreateDIBSection(hdc,&bitmapinfo,DIB_RGB_COLORS,(void**)pbuf,NULL,0);

			//Zeilenweise in Bitmap schreiben
			for (int z=0;z< *height;z++) {
				memcpy(*pbuf +((*height - z - 1) * *width * 4),bts + (*width * z * 4),*width*4);
			}
			delete [] bts;
			delete [] unc;
			DeleteDC(hdc);


			return m_hbitmap;
}
 BYTE* SetImageTransDC(CMyBitmap * button,HDC dc, UINT IDBT, int x, int y,HWND hwnd)
{
	BYTE * BUF=NULL;
	int width=0;
	int height=0;
	int z=0;
	int dcw=SCREEN_W,dch=SCREEN_H;
//	POINT dcpt;

	
	if(hwnd)
	{
		CRect rc;
		GetClientRect(hwnd,&rc);
		dcw =rc.Width();dch=rc.Height();
	}

	HDC temp=CreateCompatibleDC(dc);

	BYTE * pBufF = NULL;
	button->m_hBitmap = LoadIPNImage(IDBT,&pBufF, &width, &height, TRUE);

	//
	BITMAPINFO	bitmapinfo	= {0};
	BYTE *		pbuf		= NULL;

	bitmapinfo.bmiHeader.biSize		= sizeof(BITMAPINFOHEADER);
	bitmapinfo.bmiHeader.biWidth	= dcw;
	bitmapinfo.bmiHeader.biHeight	= dch;
	bitmapinfo.bmiHeader.biPlanes	= 1;
	bitmapinfo.bmiHeader.biBitCount = 32;
	bitmapinfo.bmiHeader.biCompression = BI_RGB;


	HBITMAP m_hbitmap = ::CreateDIBSection(temp,&bitmapinfo,DIB_RGB_COLORS,(void**)&pbuf,NULL,0);
	HBITMAP ob = (HBITMAP)::SelectObject(temp,m_hbitmap);
	::BitBlt(temp,0,0,dcw,dch,dc,0,0,SRCCOPY);
	x+=z;
	x-=z;
	if (button->m_hBitmap != 0) {
		button->m_nID = IDBT;
		Mix(&pBufF,pbuf,x, y,width, height);
		button->m_pBuf = pBufF;
	} else {
		button->LoadBitmap(IDBT);
	}
	::SelectObject(temp,ob);
	DeleteObject(m_hbitmap);
	return pBufF;
}//*/
 void SetImageTrans(CMyBitmap * button,UINT IDBK, UINT id, int x, int y)
{
	BYTE * BUF=NULL;
	int width=0;
	int height=0; 
	BKIMG_T *pbkImg = g_mapBK.Lookup(IDBK);
	if(pbkImg)		BUF = pbkImg->pBuf;
	else{
		BKIMG_T* pbkImg=new BKIMG_T ;
		pbkImg->hBmp = LoadIPNImage(IDBK, &pbkImg->pBuf, &width, &height, TRUE);
		pbkImg->id = IDBK;
		g_mapBK.Add(IDBK,pbkImg);
		
	}
/*	if (IDBK == IDB_BK_APPS) {
		if (BGAPP == 0) {
			BGAPP = LoadIPNImage(IDBK, &pBufBGAPP, &width, &height, TRUE);
		}
		BUF = pBufBGAPP;
	}else 
	if (IDBK == IDBI_BK_LISTE) {
		if (BGLISTE == 0) {
			BGLISTE = LoadIPNImage(IDBK, &pBufBGLISTE, &width, &height, TRUE);
		}
		BUF = pBufBGLISTE;
	}else  if (IDBK == IDB_BK_PHONE) { 
		if (hBmpBGPHONE == 0) {
			hBmpBGPHONE = LoadIPNImage(IDBK, &pBufBGPHONE, &width, &height, TRUE);
		}
		BUF = pBufBGPHONE;
	}else
	if (IDBK == IDBI_BK) {
		if (BG == 0) {
			BG = LoadIPNImage(IDBK, &pBufBG, &width, &height, TRUE);
		}
		BUF = pBufBG;
	}else 
	if (IDBK == IDBI_BK_MESSAGE) {
		if (BGMESSAGE == 0) {
			BGMESSAGE = LoadIPNImage(IDBK, &pBufBGMESSAGE, &width, &height, TRUE);
		}
		BUF = pBufBGMESSAGE; 
	}else if (IDBK == IDB_BK_POP_DETAIL) {
		if (BGPOP == 0) {
			BGPOP = LoadIPNImage(IDBK, &pBufBGPop, &width, &height, TRUE);
		}
		BUF = pBufBGPop;
	}else if (IDBK == IDB_BDCOMP_BK||IDB_BDCOMP_RESET==IDBK) {
		if (BGBoardComputer == 0) {
			BGBoardComputer = LoadIPNImage(IDBK, &pBufBGBoardComputer, &width, &height, TRUE);
		}
		BUF = pBufBGBoardComputer; 
	}else
	{
		BKIMG_T *pbkImg = g_mapBK.Lookup(IDBK);
		if(pbkImg)		BUF = pbkImg->pBuf;
		else BUF = NULL;
	}
*/
	BYTE * pBufF = NULL;
	button->m_hBitmap = LoadIPNImage(id,&pBufF, &width, &height, TRUE);
	if (button->m_hBitmap != 0 ) {
		button->m_nID = id;
		if( BUF!=0 ) Mix(&pBufF,BUF,x, y,width, height);
		button->m_pBuf = pBufF;
	} else {
		button->LoadBitmapI(id);
	}

}
void FreeCached_Images()
{
/*	 if( BGLISTE ) DeleteObject(BGLISTE);BGLISTE=0;
	 if( BG ) DeleteObject(BG);BG=0;
	 if( BGMESSAGE ) DeleteObject(BGMESSAGE);BGMESSAGE=0;
	 if( BGBoardComputer ) DeleteObject(BGBoardComputer);BGBoardComputer=0;
	 if( BmpPOPDetail ) DeleteObject(BmpPOPDetail);BmpPOPDetail=0;
	 if( BGAPP ) DeleteObject(BGAPP);BGAPP=0;
	 if( hBmpBGPHONE ) DeleteObject(hBmpBGPHONE);hBmpBGPHONE=0;*/
	 for(int i=0;i<g_mapBK.GetSize();i++)
	 {
		 BKIMG_T * &  pbkImg = g_mapBK.GetValueAt(i);
		 if(pbkImg)
		 {
			 DeleteObject(pbkImg->hBmp);
			 delete pbkImg;
		 }
	 }
	 g_mapBK.RemoveAll();
}
void InitCached_Images()
{
/*	int width, height;
	BGAPP = LoadIPNImage(IDB_BK_APPS, &pBufBGAPP, &width, &height, TRUE);
	BGLISTE = LoadIPNImage(IDBI_BK_LISTE, &pBufBGLISTE, &width, &height, TRUE);
	BG = LoadIPNImage(IDBI_BK, &pBufBG, &width, &height, TRUE);
	BGMESSAGE= LoadIPNImage(IDBI_BK_MESSAGE, &pBufBGMESSAGE, &width, &height, TRUE);
	BGPOP= LoadIPNImage(IDB_BK_POP_DETAIL, &pBufBGPop, &width, &height, TRUE);
*/
}


CMyBitmap::~CMyBitmap()
{
	BOOL bOK;
#ifndef __PNG_CACHE__
	if(m_hBitmap )
	{
		if( !IsBK() )
		{
			BKIMG_T * pbkImg =g_mapBK.Lookup(m_nID);
			if(pbkImg)
			{
				g_mapBK.Remove(m_nID);
				delete pbkImg;
			}
			bOK = ::DeleteObject(m_hBitmap); 
			
		}else
		{
			Detach();
		}
		m_hBitmap=0;m_nID=0;
	}
#endif
}

	//HBITMAP m_hBitmap;
HBITMAP CMyBitmap::LoadBitmapI(UINT id)
{
	m_hBitmap = SHLoadImageResource(NULL, id );//m_hBitmap = CBitmap::LoadBitmap(id);
	if(m_hBitmap) m_nID = id;
	return m_hBitmap;
}
BOOL CMyBitmap::IsBK()
{
/*	if(m_nID== IDBI_BK_LISTE || m_nID== IDB_BK_POP_DETAIL  || m_nID== IDB_BK_APPS ||
			m_nID== IDBI_BK || m_nID == IDBI_BK_MESSAGE || m_nID == IDB_BDCOMP_BK ||  m_nID == IDB_BK_PHONE)
		return TRUE;
	return FALSE;*/
	if(m_nAttr& IMG_ATTR_BK) return TRUE;
	else return FALSE;
}
HBITMAP CMyBitmap::LoadBitmap(UINT id,UINT BKID,int x, int y)
{
	if(id<=0) return NULL;
#ifndef __PNG_CACHE__
	if(m_hBitmap && !IsBK() ) ::DeleteObject(m_hBitmap);
#endif	
	m_hBitmap=0; m_nID=0;
/*
	if(!IsBK())
	{
		if(id== IDBI_BK_LISTE || id== IDB_BK_POP_DETAIL  || id== IDB_BK_APPS ||
			id== IDBI_BK || id == IDBI_BK_MESSAGE || id == IDB_BDCOMP_BK ||  id == IDB_BK_PHONE
			|| id==IDB_BK_POP_NEW|| id==IDB_BK_POP_zurueck)
			m_nAttr|= IMG_ATTR_BK ;
	}
	if(id== IDB_BK_POP_DETAIL || id==IDB_BK_POP_NEW|| id==IDB_BK_POP_zurueck) 
		m_nAttr|= IMG_ATTR_TRANSPARENT 
		*/;
	if(!m_hBitmap){
#ifdef __PNG_CACHE__
		
		m_hBitmap = PNGCache_Lookup(id);
			
		if(m_hBitmap==NULL)
		{
			m_hBitmap=::LoadBitmapW(  GetSkinHandle(),MAKEINTRESOURCE(id) ); 
			if(m_hBitmap==NULL) m_hBitmap = SHLoadImageResource(GetInst(), id );

			PNGCache_Add(id, m_hBitmap);
		}
#else
		int width,height;
/*		switch(id){
			
		case IDB_BK_APPS:
			if (!BGAPP)	BGAPP = LoadIPNImage(id, &pBufBGAPP, &width, &height, TRUE);
			m_hBitmap = BGAPP;
			break;
		case IDBI_BK_LISTE:
			if (!BGLISTE)	BGLISTE = LoadIPNImage(id, &pBufBGLISTE, &width, &height, TRUE);
			m_hBitmap = BGLISTE;
			break;
		case IDB_BK_PHONE:
			if (!hBmpBGPHONE)	hBmpBGPHONE = LoadIPNImage(id, &pBufBGPHONE, &width, &height, TRUE);
			m_hBitmap = hBmpBGPHONE;
			break;
			
		case IDBI_BK:
			if (!BG) BG = LoadIPNImage(id, &pBufBG, &width, &height, TRUE);
			m_hBitmap = BG;
			break;
		case IDBI_BK_MESSAGE:
			if (!BGMESSAGE)	 BGMESSAGE= LoadIPNImage(id, &pBufBGMESSAGE, &width, &height, TRUE);
			m_hBitmap = BGMESSAGE;
			break;
		case IDB_BK_POP_DETAIL:
			if (!BGPOP)
			{
				BGPOP= LoadIPNImage(id, &pBufBGPop, &width, &height, TRUE);
			}
			if (!BmpPOPDetail)
			{
				BmpPOPDetail= LoadBitmapI( IDB_BK_POP_DETAIL_PNG);
				
			}else m_hBitmap = BmpPOPDetail;
			
			break;
		case IDB_BDCOMP_BK:
			if (!BGBoardComputer) BGBoardComputer= LoadIPNImage(id, &pBufBGBoardComputer, &width, &height, TRUE);
			m_hBitmap = BGBoardComputer;
		
		default: // 
			 SetImageTrans(this,BKID,id,x,y);
			
			break;
		 
		}
*/
		
		if( (m_nAttr&IMG_ATTR_BK) )
		{
			BKIMG_T*  pbkImg =	g_mapBK.Lookup(id);
			if(!pbkImg) 
			{
				pbkImg=new BKIMG_T ;
				if(  !(m_nAttr&IMG_ATTR_TRANSPARENT) )
				{
					pbkImg->hBmp = LoadIPNImage(id, &pbkImg->pBuf, &width, &height, TRUE);
					m_hBitmap = pbkImg->hBmp;
				}else 
				{
					HDC hDC = GetDC(NULL);
					pbkImg->pBuf =  SetImageTransDC(this, hDC, id,0,0);
					ReleaseDC(NULL,hDC);
					pbkImg->hBmp =m_hBitmap ;
				}
				
				pbkImg->id = id;
				g_mapBK.Add(id,pbkImg);
			}else
			{
				if(  (m_nAttr&IMG_ATTR_TRANSPARENT) )
				{
					::DeleteObject(pbkImg->hBmp);
					HDC hDC = GetDC(NULL);
					pbkImg->pBuf =  SetImageTransDC(this, hDC, id,0,0);
					ReleaseDC(NULL,hDC);
					pbkImg->hBmp =this->m_hBitmap ;
					
				}else
				m_hBitmap = pbkImg->hBmp;
			}
		}else
		{
			 SetImageTrans(this,BKID,id,x,y);
		}
		
		
#endif
	}
	if(m_hBitmap) m_nID = id;
	return (m_hBitmap);
} 

HBITMAP CMyBitmap::LoadBitmap(LPCTSTR szPath)
{
#if 0
	if(szPath==NULL) return NULL;
#ifndef __PNG_CACHE__
	if(m_hBitmap) ::DeleteObject(m_hBitmap);
#endif
	m_hBitmap=0; 
	//m_hBitmap = CBitmap::LoadBitmap(szPath);
	if(!m_hBitmap){
#ifdef __PNG_CACHE__
		CString str(szPath);
		m_hBitmap = PNGCache_Lookup(str);
		if(m_hBitmap==NULL)
		{
			m_hBitmap = SHLoadImageFile( szPath );
			PNGCache_Add(str, m_hBitmap);
		}
#else
		m_hBitmap = SHLoadImageFile( szPath );
#endif
	
	}
#endif
	return (m_hBitmap);
}
#ifndef USER_SAT_NUM
#define USER_SAT_NUM  0
#endif
#ifndef USER_IS_CAR_DRIVING
#define USER_IS_CAR_DRIVING  0
#endif 
#ifndef USER_JOBAPP_SPEED
#define USER_JOBAPP_SPEED  0
#endif 
#ifndef USER_JOBAPP_SERVER_HELLO
#define USER_JOBAPP_SERVER_HELLO 0
#define USER_JOBAPP_CLIENT_HELLO 0
#define USER_JOBAPP_LAT 0
#define USER_JOBAPP_LON 0
#define USER_JOBAPP_SPEED 0
#endif

HWND hWndMenuListenerWindow=0;
static float g_fLat=9999., g_fLon=9999., g_fSpeedCar=0.;
static int g_satNum = 0,g_isCarDriving = 0;
void handle_menu_message(HWND hWnd,UINT message, WPARAM wParam, LPARAM lParam)
{
  if (message==USER_JOBAPP_SERVER_HELLO) {
	  hWndMenuListenerWindow = (HWND) wParam;
	  __ALARM_LOG__("GetMENUHander(%x)\n",wParam);
	  if ((int) lParam != 0) {
		  ::PostMessage(hWndMenuListenerWindow,USER_JOBAPP_CLIENT_HELLO,(WPARAM) hWnd,1);
	  }
  } else if (message==USER_JOBAPP_LAT) {
	  if ((int) lParam != 0) {
		uint l = (uint) wParam;
		g_fLat= (float) l / 10000.0;
		__ALARM_LOG__("USER_JOBAPP_LAT(%f)\n",g_fLat);
		
	  }
  } else if (message==USER_JOBAPP_LON) {
	  if ((int) lParam != 0) {
		uint l = (uint) wParam;
		g_fLon= (float) l / 10000.0;
		__ALARM_LOG__("USER_JOBAPP_LAT(%f)\n",g_fLat);
	  }

  }else if (message==USER_SAT_NUM) {
	  if ((int) lParam != 0) {
		g_satNum = wParam;
		__ALARM_LOG__("USER_SAT_NUM(%d)\n",g_satNum);
	  }

  }else if (message==USER_IS_CAR_DRIVING) {
	  if ((int) lParam != 0) {
		g_isCarDriving = wParam;
		__ALARM_LOG__("USER_IS_CAR_DRIVING(%d)\n",g_isCarDriving);
	  }

  }else if (message==USER_JOBAPP_SPEED) {
	  if ((int) lParam != 0) {
		g_fSpeedCar = wParam;
		__ALARM_LOG__("USER_JOBAPP_SPEED(%.2f)\n",g_fSpeedCar);
	  }

  }
  
  /*else if(message== WM_TIMER)
  {
	
	PostMessage(hWndMenuListenerWindow,USER_JOBAPP_LAT,0,0);
	PostMessage(hWndMenuListenerWindow,USER_JOBAPP_LON,0,0);

  }*/
}


int get_location_new(TCHAR* wLat,TCHAR* wLon)
{
	 
	 if(g_fLon!=9999. && g_fLat!=9999.)
	 {
		 char szLat[16],szLon[16];
		 sprintf(szLat,"%.4f",g_fLat);
		 sprintf(szLon,"%.4f",g_fLon);
		 mbstowcs(wLat,szLat,strlen(szLat)+1);
		 mbstowcs(wLon,szLon,strlen(szLon)+1);
		 return 0;
	 }

#ifdef _X86_
	return 0;
#endif
	 return -1;
}

void handle_geo_update(HWND hWnd ,DWORD wParam,const TCHAR* szWindowClass)
{
	if(wParam==0x88)
	{
	  if (!hWndMenuListenerWindow || !IsWindow(hWndMenuListenerWindow)) 
	  {    
		  
		  RegisterClient(szWindowClass);
	  }else{
		  if(USER_JOBAPP_LAT) 
			  PostMessage(hWndMenuListenerWindow,USER_JOBAPP_LAT,0,0);
		  if(USER_JOBAPP_LON) 
			  PostMessage(hWndMenuListenerWindow,USER_JOBAPP_LON,0,0);
		  if(USER_SAT_NUM!=0) 
		  {  
			  __ALARM_LOG__("post USER_SAT_NUM(%x) \n",USER_SAT_NUM);
			  PostMessage(hWndMenuListenerWindow,USER_SAT_NUM,0,0);
		  }
		  if(USER_IS_CAR_DRIVING!=0) 
			  PostMessage(hWndMenuListenerWindow,USER_IS_CAR_DRIVING,0,0);
		  if(USER_JOBAPP_SPEED!=0) 
			  PostMessage(hWndMenuListenerWindow,USER_JOBAPP_SPEED,0,0);
		  
	  }
	}
}

static void RegisterClient(const TCHAR* szWindowClass)
{
     if(!hWndMenuListenerWindow || !IsWindow(hWndMenuListenerWindow))
     {

       HWND hWnd = FindWindow(szWindowClass,NULL);
       if(hWnd){
		   if(USER_JOBAPP_CLIENT_HELLO) {
				 __ALARM_LOG__("Post USER_JOBAPP_CLIENT_HELLO(%x) \n",USER_JOBAPP_CLIENT_HELLO);
				 ::SendNotifyMessage(HWND_BROADCAST,USER_JOBAPP_CLIENT_HELLO,(WPARAM) hWnd,0);
		   }
       }

     }

}
static char alphabet[] ="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";

/* aaaack but it's fast and const should make it shared text page. */
static const unsigned char pr2six[256] =
{
    /* ASCII table */
    64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64,
    64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64,
    64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 62, 64, 64, 64, 63,
    52, 53, 54, 55, 56, 57, 58, 59, 60, 61, 64, 64, 64, 64, 64, 64,
    64,  0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14,
    15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 64, 64, 64, 64, 64,
    64, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37, 38, 39, 40,
    41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 51, 64, 64, 64, 64, 64,
    64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64,
    64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64,
    64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64,
    64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64,
    64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64,
    64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64,
    64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64,
    64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64, 64
};

int base64_decode_len(const char *bufcoded)
{
    int nbytesdecoded;
    register const unsigned char *bufin;
    register int nprbytes;

    bufin = (const unsigned char *) bufcoded;
    while (pr2six[*(bufin++)] <= 63);

    nprbytes = (bufin - (const unsigned char *) bufcoded) - 1;
    nbytesdecoded = ((nprbytes + 3) / 4) * 3;

    return nbytesdecoded + 1;
}

int base64_decode(char *bufplain, const char *bufcoded)
{
    int nbytesdecoded;
    register const unsigned char *bufin;
    register unsigned char *bufout;
    register int nprbytes;

    bufin = (const unsigned char *) bufcoded;
    while (pr2six[*(bufin++)] <= 63);
    nprbytes = (bufin - (const unsigned char *) bufcoded) - 1;
    nbytesdecoded = ((nprbytes + 3) / 4) * 3;

    bufout = (unsigned char *) bufplain;
    bufin = (const unsigned char *) bufcoded;

    while (nprbytes > 4) {
    *(bufout++) =
        (unsigned char) (pr2six[*bufin] << 2 | pr2six[bufin[1]] >> 4);
    *(bufout++) =
        (unsigned char) (pr2six[bufin[1]] << 4 | pr2six[bufin[2]] >> 2);
    *(bufout++) =
        (unsigned char) (pr2six[bufin[2]] << 6 | pr2six[bufin[3]]);
    bufin += 4;
    nprbytes -= 4;
    }

    /* Note: (nprbytes == 1) would be an error, so just ingore that case */
    if (nprbytes > 1) {
    *(bufout++) =
        (unsigned char) (pr2six[*bufin] << 2 | pr2six[bufin[1]] >> 4);
    }
    if (nprbytes > 2) {
    *(bufout++) =
        (unsigned char) (pr2six[bufin[1]] << 4 | pr2six[bufin[2]] >> 2);
    }
    if (nprbytes > 3) {
    *(bufout++) =
        (unsigned char) (pr2six[bufin[2]] << 6 | pr2six[bufin[3]]);
    }

    *(bufout++) = '\0';
    nbytesdecoded -= (4 - nprbytes) & 3;
    return nbytesdecoded;
}

void base64_encode(BYTE* data,int length, BYTE*& out) 
{

    static char alphabet[] ="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";
	    out = new BYTE[ ((length + 2) / 3) * 4+1];
		memset(out,0,((length + 2) / 3) * 4+1 );
        //
        // 3 bytes encode to 4 chars.  Output is always an even
        // multiple of 4 characters.
        //
        for (int i = 0, index = 0; i < length; i += 3, index += 4) {
            BOOL quad = false;
            BOOL trip = false;

            int val = (0xFF & data[i]);
            val <<= 8;
            if ((i + 1) < length) {
                val |= (0xFF & data[i + 1]);
                trip = true;
            }
            val <<= 8;
            if ((i + 2) < length) {
                val |= (0xFF & data[i + 2]);
                quad = true;
            }
            out[index + 3] = alphabet[(quad ? (val & 0x3F) : 64)];
            val >>= 6;
            out[index + 2] = alphabet[(trip ? (val & 0x3F) : 64)];
            val >>= 6;
            out[index + 1] = alphabet[val & 0x3F];
            val >>= 6;
            out[index + 0] = alphabet[val & 0x3F];
        }
        //return out;
    
}
float convert_NMEA2Geodec(float in) 
{
      float temp = in / 100.0;
      float degpart = floor(temp);
      float minpart = (temp-degpart) * 100.0 / 60.0;
      return degpart + minpart;
}
int get_location_geo2(float *pfLat, float* pfLon)
{
	TCHAR wLat[32]=L"",wLon[32]=L"";
	TCHAR *endptr=0;
	int r = get_location_new( wLat,  wLon);


	*pfLat= (float)wcstod(wLat,&endptr);
	*pfLon = (float)wcstod(wLon,&endptr);
	*pfLat = convert_NMEA2Geodec(*pfLat );
	*pfLon  = convert_NMEA2Geodec(*pfLon);	

#if  defined(_X86_) && defined(_DEBUG) 
	*pfLat = 50.09078900;
	*pfLon = 10.26403300;
#endif
	return r;
}

int get_location_geo(TCHAR *wLat, TCHAR* wLon)
{
	char zLat[32],zLon[32];
	TCHAR *endptr=0;
	int r = get_location_new( wLat,  wLon);

	float	myLat =(float) wcstod(wLat,&endptr);
	float	myLon = (float)wcstod(wLon,&endptr);
		
   myLat = convert_NMEA2Geodec(myLat);
    myLon = convert_NMEA2Geodec(myLon);
	sprintf(zLat,"%f",myLat);
	sprintf(zLon,"%f",myLon);
	mbstowcs(wLat,zLat, strlen(zLat)+1);
	mbstowcs(wLon,zLon, strlen(zLon)+1);
	return r;
}
int get_sate_number()
{
#if 0
	HANDLE hMap;
	HANDLE hFree;
	HANDLE hExec;
	HANDLE hDone;
	TSharedMemory *pMsg;
	int num=0;

	hExec = ::CreateEvent(NULL,FALSE,FALSE,TEXT("IMTP.Exec"));
	hDone = ::CreateEvent(NULL,FALSE,FALSE,TEXT("IMTP.Done"));
	bool bClient=false;

	  bClient=false;
	  hMap = ::CreateFileMapping((HANDLE)0xFFFFFFFF,NULL,PAGE_READWRITE,0,
								   sizeof(TSharedMemory),
								   TEXT("IMTP.LoginRequest"));
	  // Check if file mapping object already exists. If it does, then this is a 
	  // client and in this case open existing file mapping object. Client also
	  // needs to create a mutex object to synchronize access to the server
	  if (GetLastError() == ERROR_ALREADY_EXISTS) {
		hFree = ::CreateMutex(NULL,FALSE,TEXT("IMTP.Free"));
		bClient=true;
	  } else {
		CloseHandle(hMap);
	  }
	  if (bClient) 
	  {
	        if (::WaitForSingleObject(hFree,2000) == WAIT_OBJECT_0) {
				int sz=sizeof(TSharedMemory);
				pMsg = (TSharedMemory*)::MapViewOfFile(hMap,FILE_MAP_ALL_ACCESS,0,0,sizeof(TSharedMemory));

				pMsg->Service=5;

				::SetEvent(hExec);
				// Wait for server to finish
				if (::WaitForSingleObject(hDone,2000) == WAIT_OBJECT_0) 
				{
                    if (pMsg->Type == 2) //Es kommt ein String- Wert zurck
                    {
						num = pMsg->Values[0]-'0';
						if(pMsg->Len>1 && pMsg->Values[1]!=0 )
						{
							//num += (pMsg->Values[1]-'0')*10;
							num= num*10 ;
							num+=(pMsg->Values[1]-'0') ;
							if(num>12)
							{
								/*TCHAR msg[64];
								pMsg->Values[2]=0;
								wsprintf(msg,L"Get data from Heiko is %s.\nThere must be something wrong!\nHeiko, Please help to check!", pMsg->Values);
								MessageBox(NULL,msg,L"Error",MB_OK);*/
							}
						}
					}
				} else {
				}
				::ReleaseMutex(hFree);
			}
	  } else {
			//wsprintf(m_Text,TEXT("Server not ready"));
	  }
	
	
	CloseHandle(hExec);
	CloseHandle(hDone);
#endif
	return g_satNum;
}



BOOL isCarDriving()
{
	if(USER_JOBAPP_SPEED!=0 && hWndMenuListenerWindow!=NULL) PostMessage(hWndMenuListenerWindow,USER_JOBAPP_SPEED,0,0);
	
	return /*g_isCarDriving ||*/ g_fSpeedCar>1.;
}
//#define LOG_NAME  "\\marker.log"
void __alarmLog(char* sFormat,...)
{
#ifdef LOG_NAME 
	FILE * g_fAlarmLog=0;
    CHAR sMsg[256];
    va_list argp;
    va_start(argp, sFormat);
    _vsnprintf(sMsg, sizeof(sMsg) - 1, sFormat, argp);

	if(!g_fAlarmLog)
		g_fAlarmLog= fopen(LOG_NAME,"a");
	fprintf(g_fAlarmLog,sMsg);
    va_end(argp);
	if(g_fAlarmLog) fclose(g_fAlarmLog);
#endif

}
typedef struct tENTRY_SOUND {
	UINT ctrl;
	LPTSTR lpFile;
}ENTRY_SOUND ;
static CSimpleArray<ENTRY_SOUND> g_arrSounds;
static  HANDLE g_hLockSound = 0;
static HANDLE g_hSoundThread = 0;
static HANDLE g_hPlaySound = 0;
extern HANDLE ghEventExit;
#define __LOCK_SOUND()	WaitForSingleObject(g_hLockSound,INFINITE) 
#define __UNLOCK_SOUND()	ReleaseMutex(g_hLockSound)
BOOL PopSound(ENTRY_SOUND& a)
{
	BOOL bEmpty = 0;
	a.ctrl = 0;a.lpFile = 0;
	__LOCK_SOUND();
	bEmpty = (g_arrSounds.GetSize()==0);
	if(!bEmpty)
	{
		 a = g_arrSounds[0];
		 //if(a.ctrl==SND_FILENAME) free(a.lpFile);
		 g_arrSounds.RemoveAt(0);	
	}
	bEmpty = (g_arrSounds.GetSize()==0);
	__UNLOCK_SOUND();
	return bEmpty;
}
void PushSound(ENTRY_SOUND& a)
{

	__LOCK_SOUND();
	g_arrSounds.Add(a);
	__UNLOCK_SOUND();
	SetEvent(g_hPlaySound);
}
#define IDR_POPUP                       7129
static  HINSTANCE mhRES = NULL;
#define SOUND_MODE  SND_ASYNC|SND_NOSTOP

BOOL __myPlaySound( LPCTSTR lpszSound,   UINT    fuSound )
{
	DWORD err = 0 ;
	BOOL b = sndPlaySound(lpszSound, fuSound);
	if(!b)
	{
		err = GetLastError();
		if(err==2) return b;
	}
	int count = 0;
	while(!b && count<10)
	{
		Sleep(1000);
		b = sndPlaySound(lpszSound, fuSound);
		count++ ;
	}
	return b;
}
static void internalPlaySound(ENTRY_SOUND &a)
{
	
	if(a.ctrl== SND_FILENAME)
	{
		TCHAR* wavFile =(TCHAR*) a.lpFile;
		__myPlaySound(wavFile, SND_FILENAME|SOUND_MODE);
		free(wavFile);
	}else if(a.ctrl== SND_MEMORY)
	{
		HANDLE  hRes;
		HRSRC hResInfo;
		LPTSTR lpRes;
		UINT nRes = (UINT) a.lpFile;
		hResInfo  = FindResource(GetInst(), (MAKEINTRESOURCE(nRes)), _T("WAVE"));
		hRes  = LoadResource(GetInst(), hResInfo);
		lpRes = (LPTSTR)LockResource (hRes);
		__myPlaySound(lpRes, SND_MEMORY|SOUND_MODE);
	}else if(a.ctrl== SND_ALIAS)
	{
		if(!mhRES)	 mhRES = ::LoadLibraryEx(_T("\\Flashdisk\\IV2_sounds.exe"),NULL,LOAD_LIBRARY_AS_DATAFILE);
		HANDLE  hRes;
		HRSRC hResInfo;
		LPTSTR lpRes;
		hResInfo  = FindResource(mhRES, (MAKEINTRESOURCE(IDR_POPUP)), _T("WAVE"));
		hRes  = LoadResource(mhRES, hResInfo);
		lpRes = (LPTSTR)LockResource (hRes);
		__myPlaySound(lpRes, SND_MEMORY|SOUND_MODE);
	}

}

static DWORD WINAPI SoundTask(void*para )
{
	//write reset command to IN folder
	//wait for back
	//get data.
	HANDLE hEvt = (HANDLE) para;

	HANDLE handles[2];
	BOOL bEmpty = 0;
	DWORD ret = 0;
	//int timeout =1000*(150);
	ENTRY_SOUND a ;
	while(1){
		handles[1]=ghEventExit;
		handles[0]=hEvt;
		ret = WaitForMultipleObjects(2, handles,FALSE,INFINITE);
		if(ret==WAIT_OBJECT_0){
			do{
				bEmpty = PopSound(a) ;
				Sleep(500);
				internalPlaySound(a);
				
			}while(!bEmpty);
			
		}else if(ret==WAIT_OBJECT_0+1)
		{
			CloseHandle(g_hLockSound ) ; 
			g_hLockSound = NULL;
			return 0;
		}
	
	}
	
	return 0;
}


void PlayCPSSSound()
{
/*	if(!mhRES)	 mhRES = ::LoadLibraryEx(_T("\\Flashdisk\\IV2_sounds.exe"),NULL,LOAD_LIBRARY_AS_DATAFILE);
    HANDLE  hRes;
    HRSRC hResInfo;
    LPTSTR lpRes;
    hResInfo  = FindResource(mhRES, (MAKEINTRESOURCE(IDR_POPUP)), _T("WAVE"));
    hRes  = LoadResource(mhRES, hResInfo);
    lpRes = (LPTSTR)LockResource (hRes);
    sndPlaySound(lpRes, SND_MEMORY|SND_ASYNC);
    //FreeLibrary(mhRES);
	*/

	ENTRY_SOUND a;
	a.ctrl = SND_ALIAS;
	a.lpFile =(LPTSTR) 0;
	PushSound(a);
	__ALARM_LOG__("PlayCPSSSound\n");

}
BOOL g_bPlaySound =1 ;
void PlaySound(int nRes,BOOL bWait)
{
/*
    HANDLE  hRes;
    HRSRC hResInfo;
    LPTSTR lpRes;
    hResInfo  = FindResource(GetInst(), (MAKEINTRESOURCE(nRes)), _T("WAVE"));
    hRes  = LoadResource(GetInst(), hResInfo);
    lpRes = (LPTSTR)LockResource (hRes);
	if(bWait)
		sndPlaySound(lpRes, SND_MEMORY|SND_SYNC);
	else sndPlaySound(lpRes, SND_MEMORY|SND_ASYNC);
   // FreeLibrary(mhRES);
   */
	if(g_bPlaySound)
	{
	ENTRY_SOUND a;
	a.ctrl = SND_MEMORY;
	a.lpFile =(LPTSTR) nRes;
	PushSound(a);
	__ALARM_LOG__("PlaySound(%d)\n",nRes);
	}
}

void PlaySoundFile(TCHAR* wavFile,BOOL bWait)
{
/*	if(bWait)
		sndPlaySound(wavFile, SND_FILENAME|SND_SYNC);
	else sndPlaySound(wavFile, SND_FILENAME|SND_ASYNC);
   // FreeLibrary(mhRES);
*/
	if(g_bPlaySound)
	{
		ENTRY_SOUND a;
		a.ctrl = SND_FILENAME;
		a.lpFile = wcsdup(wavFile);
		PushSound(a);
		__ALARM_LOG__("PlaySoundFile(%s)\n",wavFile);
	}
}


void StartSoundTask()
{	
	g_hPlaySound = CreateEvent(NULL,FALSE,FALSE,NULL);
	g_hLockSound = CreateMutex(NULL,FALSE,NULL);
	DWORD dwID;
	g_hSoundThread = CreateThread(NULL,0 , SoundTask ,(void*)g_hPlaySound,0, &dwID);
	int nPri = 	GetThreadPriority(g_hSoundThread); 
	//SetThreadPriority(g_hSoundThread,nPri-1);
}

TCHAR  g_szLang[8]=L"";
HINSTANCE SetDefaultLang(LPCTSTR lpApp, LPTSTR lpstrCmdLine)
{

	TCHAR szLang[8]=L"de";
	LPTSTR  lpLang = wcsstr( lpstrCmdLine,L"-lang=") ;
	if( NULL!=lpLang )
	{
		TCHAR* p = lpLang+6;
		szLang[0]=*p++;szLang[1]=*p++;
		*p=0;
		wcscpy(g_szLang,szLang);
		
	}
/*	LCID langMap[]={
		 MAKELANGID(LANG_ENGLISH, SUBLANG_ENGLISH_US),
		 MAKELANGID(LANG_FRENCH, SUBLANG_FRENCH),
		 MAKELANGID(LANG_GERMAN, SUBLANG_GERMAN),
		 MAKELANGID(LANG_ITALIAN, SUBLANG_ITALIAN),
		 MAKELANGID(LANG_SPANISH, SUBLANG_SPANISH),
		 MAKELANGID(LANG_TURKISH, SUBLANG_DEFAULT)
	};

if(iLang>5) iLang = 2;
LCID lcid = MAKELCID(langMap[iLang], SORT_DEFAULT);
*/
#ifdef UNDER_CE
//	SetUserDefaultLCID(lcid);
//	SetUserDefaultUILanguage(lcid);
//	SetSystemDefaultLCID(lcid); 
	TCHAR resPath[64];
	wsprintf(resPath,L"\\FlashDisk\\LangPacks\\%s_%s.dll",lpApp,szLang);
	HINSTANCE hRes = LoadLibrary(resPath);
	return hRes;
#else
	CTempLocale tloc(lcid);
#endif

}


HBITMAP GetBKDCBmp(HDC dc, int x,int y, int dcw, int dch ,BYTE **ppbuf)
{
	BYTE * BUF=NULL;
	int width=0;
	int height=0;
	int z=0;
/*	int dcw=SCREEN_W,dch=SCREEN_H;

	if(hwnd)
	{
		CRect rc;
		GetClientRect(hwnd,&rc);
		dcw =rc.Width();dch=rc.Height();
	}
*/
	HDC temp=CreateCompatibleDC(dc);

//	BYTE * pBufF = NULL;
//	button->m_hBitmap = LoadIPNImage(IDBT,&pBufF, &width, &height, TRUE);

	//
	BITMAPINFO	bitmapinfo	= {0};
	//BYTE *		pbuf		= NULL;

	bitmapinfo.bmiHeader.biSize		= sizeof(BITMAPINFOHEADER);
	bitmapinfo.bmiHeader.biWidth	= dcw;
	bitmapinfo.bmiHeader.biHeight	= dch;
	bitmapinfo.bmiHeader.biPlanes	= 1;
	bitmapinfo.bmiHeader.biBitCount = 32;
	bitmapinfo.bmiHeader.biCompression = BI_RGB;


	HBITMAP m_hbitmap = ::CreateDIBSection(temp,&bitmapinfo,DIB_RGB_COLORS,(void**)ppbuf,NULL,0);
	HBITMAP ob = (HBITMAP)::SelectObject(temp,m_hbitmap);
	::BitBlt(temp,0,0,dcw,dch,dc,x,y,SRCCOPY);
	::SelectObject(temp,ob);
	DeleteDC(temp);
	return m_hbitmap;
}
 BYTE* LoadImageWithBK(CMyBitmap * button,UINT IDBT, int& x, int& y,BYTE* pBKBuf,int wBK,int hBK)
{
	int width, height;
//	x-=gRectToolbar.left;y-=gRectToolbar.top
	BYTE * pBufF = NULL;
	button->m_hBitmap = LoadIPNImage(IDBT,&pBufF, &width, &height, TRUE);
	if(y+height>=hBK)
	{	
		height=hBK-y-1;
	}
	if (button->m_hBitmap != 0) {
		button->m_nID = IDBT;
		Mix(&pBufF,pBKBuf,x, y,width, height, wBK, hBK);
	} else {
		button->LoadBitmap(IDBT);
	}

	
	return pBufF;
}

BOOL get_ver(TCHAR* szVer)
{
	BOOL r = FALSE;
	char * pBuf = NULL;
	HGLOBAL hRes = 0;
	HRSRC hRsrc = FindResource(GetInst() ,MAKEINTRESOURCE(IDR_VER_APP),TEXT("FILES") );
	if(hRsrc){
		hRes = LoadResource(GetInst(), hRsrc);
		pBuf = (char*)LockResource(hRes);
	 }
	if(pBuf)
	{
		int year = ( (pBuf[0]&0xff)<<8) + (pBuf[1]&0xff);
		int month = (pBuf[2]&0xff);
		int day = (pBuf[3]&0xff);
		int count = ((pBuf[4]&0xff)<<8) + (pBuf[5]&0xff);
		wsprintf(szVer,L"Version: %02d.%02d.%04d 00:00 - %d", day,month,year, count);
		r= TRUE;
	}
	if(hRes){ FreeResource(hRes);}
	return r;
}
/*
int get_info_text(int i, char* szText)
{
	if (!hWndMenuListenerWindow || !IsWindow(hWndMenuListenerWindow))
	{
		sprintf(szText,"MenuListenerWindow==NULL");
		return 0;
	}
	handle_geo_update(NULL ,0x88,NULL);
	switch(i){
	case 100:  
			sprintf(szText,"%.2f",g_fLat ); 
		break;
	case 101: 
			sprintf(szText,"%.2f",g_fLon );
	 
		break;
	case 102:
		 
			sprintf(szText,"%d",g_satNum );
		 
		break;
	case 103: //
		 sprintf(szText,"%d",g_fSpeedCar );
		
		break;
	case 104:		 
			sprintf(szText,"%s",g_isCarDriving?"ON":"OFF" );
		 break;
	default:
		return -1;
	}
	return 0;
}
*/
void os_reboot()
{
	FILE *f = fopen("\\DATAoverIP\\IN\\boot.win","wt");
	if(f)
	{
		char * reboot = "reboot\n";
		fwrite(reboot, 1, strlen(reboot), f);
		fclose(f);
	}
}

void os_enable_ble_fw()
{
	FILE *f = fopen("\\DATAoverIP\\OUT\\config.dat","wt");
	if(f)
	{
		char * reboot = "1\nGPS+USEBLE=08\nGPS+SAVE\n";
		fwrite(reboot, 1, strlen(reboot), f);
		fclose(f);
	}
}