#include "stdafx.h"
 
#include "cpss_dialog.h"
#include <stdio.h>
#include "WirtschaDlg.h"

 




extern CSimpleArray<FMS_SAVE> g_fmsPool;

 
 typedef struct {
	UINT nID; // str ID , -1 is direct string
	char  pstr[16]; // used when nID==-1
	RECT  rt;
 
	CMyBitmap placehold;
	
}  DISPLAY_CELL;


 struct ICON_DEF{
	 int id;
	 int x,y;
 };
#define BAR_H 	 54 
#define BAR_W	 249
#define RASTER_X 520
#define RASTER_Y 148
#define RASTER_W 262
#define RASTER_H 199
static const ICON_DEF ids[]={
	 {IDB_Wirt_THUMB,670,27 }, {IDB_Wirt_RASTER, RASTER_X,RASTER_Y} , {IDB_Wirt_BAR1,RASTER_X+13,RASTER_Y+8 },{IDB_Wirt_BAR2,RASTER_X+13,RASTER_Y+75 }, {IDB_Wirt_BAR1,RASTER_X+13,RASTER_Y+140 }
	, {IDB_Wirt_THUMB2,670,27 } 
};
 #define m_btnlist m_Btns
 #define m_btAct (&m_Btns[1])


//static DWORD WINAPI CommandTask(void*para );

DISPLAY_CELL   display_cell []={
	{IDB_Wirt_SIGN80,{0}, {95,116,142,62} }, {IDB_Wirt_SIGN90,{0},{95,196,142,62} },{IDB_Wirt_SIGN100,{0},{95,274,142,62} },{IDS_WIRT_GLANG,{0},{95,374,142,62}},
	{IDS_WIRT_VERB,{0},{355,42,142,62}},{IDS_WIRT_DREH,{0},{355,116,142,62}},
	{IDS_WIRT_LEER,{0},{355,196,142,62}},{IDS_WIRT_ROLL,{0},{355,274,142,62}},{IDS_WIRT_GKURZ,{0},{355,374,142,62}}
};
 
static HWND g_hWnd=NULL;
void printf_val_h(char* ptr, DWORD dw, float factor)
{
	if(dw==0xffff) sprintf(ptr,"---");
	else sprintf(ptr,"%.1f %%", (dw)*factor);
}
void wirt_callback(unsigned char* buf,HWND hWnd)
{
	DWORD dw;
	if(buf==NULL) return;
	if( 5 ==buf[0])
	{
		if(buf[1]==1) {
			if(ShortInvalid( (&buf[2]))) strcpy(display_cell[0].pstr,"---");
			else{
				BY2HW(dw, &buf[2]); 
				printf_val_h(display_cell[0].pstr, dw, 0.1);//sprintf(display_cell[0].pstr,"%.1f %%", (dw)*0.1);
			}
			if(ShortInvalid((&buf[4]))) strcpy(display_cell[1].pstr,"---");
			else{
				BY2HW(dw, &buf[4]); 
				printf_val_h(display_cell[1].pstr, dw, 0.1);//sprintf(display_cell[1].pstr,"%.1f %%", (dw)*0.1);
			}
			if(ShortInvalid((&buf[6]))) strcpy(display_cell[2].pstr,"---");
			else{
				BY2HW(dw, &buf[6]); 
				printf_val_h(display_cell[2].pstr, dw, 0.1);//sprintf(display_cell[2].pstr,"%.1f %%", (dw)*0.1);
			}
			if(ShortInvalid((&buf[8]))) strcpy(display_cell[4].pstr,"---");
			else{
				BY2HW(dw, &buf[8]); 
				
				sprintf(display_cell[4].pstr,"%.2f %%", (dw*0.01));
			}
			if(ShortInvalid((&buf[10]))) strcpy(display_cell[5].pstr,"---");
			else{
				BY2HW(dw, &buf[10]); 
				
				sprintf(display_cell[5].pstr,"%d",  (int)(dw*125));
			}
			if(ShortInvalid((&buf[12]))) strcpy(display_cell[6].pstr,"---");
			else{
				BY2HW(dw, &buf[12]); 
				printf_val_h(display_cell[6].pstr, dw, 0.1);//sprintf(display_cell[6].pstr,"%.1f %%", (dw)*0.1);
			}
			if(ShortInvalid( (&buf[14]))) strcpy(display_cell[7].pstr,"---");
			else{
				BY2HW(dw, &buf[14]); 
				printf_val_h(display_cell[7].pstr, dw, 0.1);//sprintf(display_cell[7].pstr,"%.1f %%", (dw)*0.1); 
			}
		}else if(buf[1]==2){
			if(LongInvalid((&buf[2]))) strcpy(display_cell[3].pstr,"---");
			else{
				BY2DW(dw,&buf[2]);
				sprintf(display_cell[3].pstr,"%d", dw);
			}
			if(LongInvalid((&buf[6]))) strcpy(display_cell[8].pstr,"---");
			else{
				BY2DW(dw,&buf[6]);
				sprintf(display_cell[8].pstr,"%d", dw);
			}
		}
	} 
	if(g_hWnd!=NULL && IsWindow(g_hWnd))
	{
		InvalidateRect(g_hWnd,NULL,TRUE);
		UpdateWindow(g_hWnd);
	}
}
static const BUTTON_ITEM Button_EngInfo[] = 
{
	//{ 416, 121,	44,	    44,ID_BACKSPACE ,IDB_BACKSPACE    ,IDB_BACKSPACE_DN },  //For Name
	//{ 416, 165,	44,	    44,ID_UPICON    ,IDB_UPICON       ,IDB_UPICON_DN},
	{ Btn_CancelX, Btn_CancelY,	Btn_CancelWidth, Btn_CancelHeight,ID_CANCEL    ,IDBI_CANCEL,IDBI_CANCEL_DN},

};

static const  BUTTON_ITEMEX Button1_EngInfo[] = 
{
	//{ 416, 121,	44,	    44,ID_BACKSPACE ,IDB_BACKSPACE    ,IDB_BACKSPACE_DN },  //For Name
	//{ 416, 165,	44,	    44,ID_UPICON    ,IDB_UPICON       ,IDB_UPICON_DN},
	{ 560 , 370,	77 , 75,ID_BUTTON_RESET,IDB_BDCOMP_BUTTON_RESET , IDB_BDCOMP_BUTTON_RESET_DN,   0,0,0,0,TitleFontWide,TitleFontHeight,FW_NORMAL},
	
    
};
 

LRESULT WirtschaDlg::OnInitDialog(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
 t55_get_wirt();
	for(int i=0; i<sizeof(Button_EngInfo)/sizeof(BUTTON_ITEM) ; i++)
	{
		CREATE_BTN_TRANS2(m_btnlist[i], m_nIDBACK, Button_EngInfo[i]);
	}

	RECT rect;
	rect = Button1_EngInfo[0].rt;
	g_hWnd= m_hWnd ;
	 
	for(int i=0; i<sizeof(Button1_EngInfo)/sizeof(BUTTON_ITEMEX) ; i++)
	{
		BOOL bEnable = true;
		
		CString str;
		str.LoadString(Button1_EngInfo[i].uId );
		CREATE_BTN_TRANS(m_btAct[i], m_nIDBACK,str,Button1_EngInfo[i]);
		
	}
 
		

//	DWORD dwID;
//	ghExitEvent = CreateEvent(NULL,FALSE,FALSE,NULL);
//	g_hCommandThread = CreateThread(NULL,0 , CommandTask ,(void*)m_hWnd,0, &dwID);


//	OnButton2(0,0,0, bHandled);
	

	  
	int i=0;
	for(i=0;i< 2;i++)
	{
		m_Icons[i+3].LoadBitmap(ids[i].id,m_nIDBACK,ids[i].x, ids[i].y );
	}
	for(;i< sizeof(ids)/sizeof(ICON_DEF)-1 ;i++)
	{
		//m_Icons[i+3].LoadBitmap(ids[i].id,m_nIDBACK,ids[i].x, ids[i].y );
		int x = ids[i].x-RASTER_X, y= ids[i].y-RASTER_Y ;
		LoadImageWithBK(&m_Icons[i+3],ids[i].id, x,y,m_Icons[4].m_pBuf,RASTER_W,RASTER_H);
	}
	m_Icons[i+3].LoadBitmap(ids[i].id,m_nIDBACK,ids[i].x, ids[i].y ); // for thumb anination

	int count = g_fmsPool.GetSize() ;
	for(i=0;i<min(3,count-1);i++){
		FMS_SAVE* fms = &g_fmsPool[count-i-1];
		FMS_SAVE* fms2 = &g_fmsPool[count-i-2];
		m_maxKil[i] = (fms->f9 - fms2->f9);
		m_maxLit[i] = (fms->f8 - fms2->f8);
		m_lit[i]=0.1;
	}
	if(i>=2)
	{
		if(m_maxKil[0]/m_maxLit[0] < m_maxKil[1]/m_maxLit[1] ) 
			m_bShowThumb = 10;
	}
	//m_bShowThumb = 10;
	SetTimer(1,50,NULL);

	VButtonWnd::OnInitDialog(uMsg, wParam, lParam, bHandled) ;
    return 0;  
}
#define FACTOR 3
float WirtschaDlg::DrawBar(CCanvas& canvas, DrawDC& Draw,int idx)
{
	int count = g_fmsPool.GetSize() ;
	FMS_SAVE* fms = &g_fmsPool[count-idx-1];
	FMS_SAVE* fms2 = &g_fmsPool[count-idx-2];
/*	float kil = (fms->f9 - fms2->f9);
	float lit  = (fms->f8 - fms2->f8);
*/
	float kil = m_maxKil[idx];
	float lit = m_lit[idx];
	   
	if(kil<0.1) kil=0.1;

	int w  =(int)  (lit)*FACTOR ;
	//int x=784-w;
	//int y=160+70*idx;
	int x=ids[2+idx%3].x+BAR_W-w;    //784-w;
	int y=ids[2+idx%3].y; //160+70*idx,
	int h=BAR_H;
	RECT rect;
	TCHAR wcs[16];
	if(w>0)
	{
		rect.left = x,rect.top = y;
		rect.right = w,rect.bottom = h;
		x=BAR_W-w ;
		canvas.BitBlt(m_Icons[5+(idx%3)],SRCCOPY, rect,x,0 ,TRUE);
		rect.bottom+=rect.top;rect.right+=rect.left-6;
		rect.left-=50;
		Draw.DrawStringRect( get_month(fms->month),&rect ,DT_RIGHT|DT_VCENTER );
		wsprintf(wcs,L"%dL",(int)lit);//(fms->f8 - fms2->f8) );
		rect.right= max(rect.left,RASTER_X+70 )-6 ; rect.left=RASTER_X; 
		Draw.DrawStringRect( wcs,&rect ,DT_RIGHT|DT_VCENTER );
	}
	return lit/kil;
}

void WirtschaDlg::DrawEmptyBar(CCanvas& canvas ,int idx)
{
	int w  =11,h=BAR_H ;
	 
	int x=ids[2+idx%3].x+BAR_W-w;    //784-w;
	int y=ids[2+idx%3].y; //160+70*idx,
	RECT rect;
	if(w>0)
	{
		rect.left = x,rect.top = y;
		rect.right = w,rect.bottom = h;
		x=BAR_W-w ;
		canvas.BitBlt(m_Icons[5+(idx%3)],SRCCOPY, rect,x,0 ,TRUE);
		
	}
		 
}
static int thumb_animation[2]={ 3,8};
static int thumb_index = 0;
#define count_thumb sizeof(thumb_animation)/sizeof(int)
void WirtschaDlg::OnPaintExt(HDC hDC,CRect& rcPaint)
{
DrawDC Draw(hDC);
CCanvas canvas(hDC);
	Draw.SetDrawBkMode(TRANSPARENT);
	Draw.SetDrawTextColor(RGB(255, 255, 255));
	CRect rect;
	HFONT hOldFont = Draw.SetFont(m_hBigFont);
	CString str;
	int cols = sizeof(display_cell)/sizeof(DISPLAY_CELL);
	int i,j=0;
	for(i=0;i<cols;i++)
	{
		if(i>=3) str.LoadString(display_cell[i].nID);
		else{
			int x = display_cell[i].rt.left - 70;
			int y = display_cell[i].rt.top +8;
			if(!m_Icons[i].m_hBitmap)
			{
				m_Icons[i].LoadBitmap(display_cell[i].nID,m_nIDBACK,x,y);
			}
			canvas.BitBlt(m_Icons[i],x,y,TRUE);
		}
		rect.left= display_cell[i].rt.left;rect.top= display_cell[i].rt.top;
		rect.right= rect.left+display_cell[i].rt.right;rect.bottom= rect.top+display_cell[i].rt.bottom;
		
		//Draw.DrawNewRect2(&rect,TRUE,TRUE,FILL_CLR);
		draw_placeholder(display_cell[i].placehold,IDB_PLACE_141);
		/*if(display_cell[i].placehold.m_hBitmap==NULL)
		{
			display_cell[i].placehold.LoadBitmap(IDB_PLACE_141,m_nIDBACK,rect.left,rect.top);
		}
		canvas.BitBlt(display_cell[i].placehold,rect.left,rect.top,TRUE);*/
		Draw.DrawStringRect(convert_val( display_cell[i].pstr),&rect,DT_CENTER|DT_VCENTER);

		
		rect.right = rect.left-6;rect.left-=120;
		int style = DT_RIGHT|DT_VCENTER ;
		if(i>=3){
			Draw.DrawStringRect((LPTSTR)(LPCTSTR)str,&rect,style);
		}
	}

	canvas.BitBlt(m_Icons[4], ids[1].x,ids[1].y,TRUE);
	TCHAR wcs[16];
	int count = g_fmsPool.GetSize() ;
	float std1=0,std2=0;
	if(count>=2 )
	{
		std1 = DrawBar(canvas, Draw, 0);		 
		if(count>=3)
		{
			std2 = DrawBar(canvas, Draw,1);
/*
			if(std1<std2 )//m_bShowThumb)
			{
				canvas.BitBlt(m_Icons[3], ids[0].x,ids[0].y,TRUE);
			} 
*/			if(count>=4)
			{
				 DrawBar(canvas, Draw,2);
			}
		} 
	}else{
		int  idx=2  ;
		for(idx=2;idx>=0;idx--){
			DrawEmptyBar(canvas,idx);
		}
		
	}
	if(m_bShowThumb)
	{
		int is = thumb_animation[thumb_index++];
		if(thumb_index>= count_thumb) thumb_index = 0;
		canvas.BitBlt(m_Icons[is], ids[0].x,ids[0].y,TRUE);
		CString str;
		str.Format(L"%d%%" ,m_bShowThumb); 	
		RECT rect;
		BITMAP bm;
		m_Icons[3].GetBitmap(&bm);
		rect.left = ids[0].x; rect.top = ids[0].y+46;
		rect.right=rect.left+bm.bmWidth; rect.bottom = rect.top+30;
		HFONT hOld =Draw.SetFont(m_hFont);
		Draw.DrawStringRect((LPTSTR)(LPCTSTR)str,&rect,DT_CENTER|DT_VCENTER);
		Draw.SetFont(hOld);
		
	}
	Draw.SetFont(hOldFont);
	 
	 
}
 
LRESULT WirtschaDlg::OnReset(WORD /*wNotifyCode*/, WORD wID, HWND hWndCtl, BOOL& /*bHandled*/)
{
	 if(IDOK==AlertBox(IDS_BORD_RESET_MSG,2))
	 {
		for(int j=0;j<sizeof(display_cell)/sizeof(DISPLAY_CELL);j++)
		{
			display_cell [j].pstr[0]=0;
		}
		 
		Invalidate();UpdateWindow();
 
		t55_reset_wirt();
	 }
  return 0;
}
LRESULT WirtschaDlg::OnButton2(WORD /*wNotifyCode*/, WORD wID, HWND hWndCtl, BOOL& /*bHandled*/)
{
	 
  return 0;
}


LRESULT WirtschaDlg::OnCancelMsg(WORD /*wNotifyCode*/, WORD wID, HWND hWndCtl, BOOL& /*bHandled*/)
{
//	SetEvent(ghExitEvent);
//	if(	g_hCommandThread ) WaitForSingleObject(g_hCommandThread,TIMEOUT_COMMAND); g_hCommandThread=0;
	__restore_pre_window_handle__(m_hWnd);
	
//	CloseHandle(ghExitEvent);
	EndDialog(1);
	//PostQuitMessage(0);
	
	return 0;
}


// animation timer
LRESULT WirtschaDlg::OnTimer(UINT /*uMsg*/, WPARAM wParam, LPARAM lParam, BOOL& /*bHandled*/)
{
	BOOL bHandled=TRUE;
	RECT rect;
	BITMAP bm;
	if(wParam==1){
		for(int i=0;i<3;i++)
		{
			
			m_lit[i]+=m_maxLit[i]/50;
			if(m_lit[i]>= m_maxLit[i]){
				m_lit[i]=m_maxLit[i];
						
			}else bHandled = FALSE;
		}
		if(m_bShowThumb<100) m_bShowThumb+=2 ;
		if(bHandled && m_bShowThumb>=100)
		{
			KillTimer(1);
			SetTimer(2,500);
		}	
		m_Icons[4].GetBitmap(&bm);
		rect.left = ids[1].x; rect.top = ids[1].y ;
		rect.right=rect.left+bm.bmWidth; rect.bottom = rect.top+bm.bmHeight;
		::InvalidateRect(m_hWnd,&rect,TRUE);
	}
		
	 
	m_Icons[3].GetBitmap(&bm);
	
	//rect.left = ids[0].x; rect.top = ids[0].y+46;
	//rect.right=rect.left+bm.bmWidth; rect.bottom = rect.top+30;
	//rect.left = ids[0].x; rect.top = ids[0].y ;
	//rect.right=rect.left+bm.bmWidth; rect.bottom = rect.top+bm.bmHeight;
	rect.left = ids[0].x + 32; rect.top = ids[0].y +16;
	rect.right= ids[0].x + 54; rect.bottom =  ids[0].y +32;
	::InvalidateRect(m_hWnd,&rect,TRUE);
	//UpdateWindow();
	 
	return 0;
}





LRESULT WirtschaDlg::OnUserIndicate(UINT /*uMsg*/, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
 
	return 0;
}
 