#include "stdafx.h"
 #include "cpss_dialog.h"

extern HANDLE ghEventMsg;
BOOL CleanupFile(TCHAR* wcs);
static void AlertWndMessage(HDC hDC,TCHAR *msg,TCHAR * pExtra=0)
{
	DrawDC Draw(hDC);

	Draw.SetDrawBkMode(TRANSPARENT);
	Draw.SetDrawTextColor(RGB(0,0,0));
	//Draw.SetDrawFontSize( LongTitleFontHeight+4, LongTitleFontWide+2,FW_BOLD,__FONT_NORMAL__);
	if(pExtra==0){
		Draw.SetDrawFontSize(FontHeight,FontWide,FW_NORMAL,__FONT_NORMAL__);
		Draw.DrawGPSOverIPStringRect(msg,CRect(140,120,668,394),DT_LEFT/*|DT_VCENTER*/|DT_EXPANDTABS|DT_WORDBREAK );
	}else{
		Draw.SetDrawFontSize(TitleFontHeight,TitleFontWide,FW_BOLD,__FONT_NORMAL__);
		Draw.DrawGPSOverIPStringRect(msg,CRect(240,120,568,394),DT_CENTER/*|DT_VCENTER*/|DT_EXPANDTABS|DT_WORDBREAK );

		Draw.SetDrawFontSize(FontHeight,FontWide,FW_NORMAL,__FONT_NORMAL__);
		Draw.DrawGPSOverIPStringRect(pExtra,CRect(150,170,658,394),DT_LEFT/*|DT_VCENTER*/|DT_EXPANDTABS|DT_WORDBREAK );
	}
}
 static BOOL FileIsExist()
 {
	 CString strProg = __FLASHDISK_W_ L"\\Bordcomputer.exe" ;
	 WIN32_FIND_DATA fndData;
	HANDLE hFind;
	hFind = FindFirstFile(strProg, &fndData);	
	if (INVALID_HANDLE_VALUE != hFind) 	
	{
		CloseHandle(hFind);
		return TRUE;
	}
	return FALSE;
 }
 int showBordAlert(int type)
{
	static BOOL bInPopup = FALSE;
	if(bInPopup) return 0;
	bInPopup=1;
	int msgId = IDS_BORD_ALERT_TITLE;
	int extraId = IDS_BORD_ALERT_TEXT;
	CString	strTitle;
	strTitle.LoadString(msgId);
    BUTTON_ITEM Button_Cancel[] = 
   {
	{ 592, 296,	Btn_CancelWidth, Btn_CancelHeight,ID_CANCEL    ,IDBI_CANCEL,IDBI_CANCEL_DN},

   { 0, 0,	0, 0,0    ,0     ,0}};
    BUTTON_ITEMEX Button_Confirm[2]= {
				{ 210, 296,	201, 75,IDOK      ,IDB_BUTTON250,IDB_BUTTON250_DN,0,0,0,0,TitleFontWide,TitleFontHeight,FW_NORMAL ,IDS_BORD_ALERT_BTN},
				//{ 420, 280,	201, 75,IDCANCEL   ,IDBI_BUTTON_121x43,IDBI_BUTTON_121x43_DN,0,0,0,0,TitleFontWide,TitleFontHeight,FW_NORMAL,IDS_NO},
				{ 0, 0,	0, 0,0    ,0     ,0}};

	CpssMsgDlg dlg1(IDB_BK_Reifendruck_POP,strTitle,0);	
	dlg1.m_BmpButtonTmpl =  Button_Cancel;
	dlg1.m_TxtButtonTmpl =  Button_Confirm;
	dlg1.fnDrawMessage = AlertWndMessage;
	dlg1.m_bSound=1;
	dlg1.m_szExtraSound = _T("\\FlashDisk\\voice\\germany\\tire-alarm.wav");
	if(extraId!=0){
		strTitle.LoadString(extraId);
		CString str(L"\t       ");
		str+= strTitle;
		dlg1.SetExtraText((LPTSTR)(LPCTSTR)str);
	}
	int ret =  dlg1.DoModal();
	bInPopup=0;
	return ret;
	if(ret==IDOK)
	{
		HANDLE handler;
		TCHAR wzParam[32];
		wsprintf(wzParam,L"-alert=%d" , type);
		//SetEvent(ghEventMsg);
		//if(FileIsExist())
		//	CreateProg_NoWait(FALSE, __FLASHDISK_W_ L"\\Bordcomputer.exe",wzParam,&handler);
		//else CreateProg_NoWait(FALSE, __FLASHDISK_W_ L"\\Boardcomputer.exe",wzParam,&handler);
	}
	return ret;
}

#if 0
void reifen_callback(unsigned char* buf)
{
	DWORD dw;

	if( buf[1]==3)
	{
		int tire = buf[2];
		showBordAlert(tire);
		/*DISPLAY_CELL* cell = find_tire( tire)	;
		if(cell)
		{
			cell->press = (buf[3]&0xff)*4./100;
			DWORD dw= BY2HW(dw, &buf[4]);
			cell->temp = (dw)*0.03125-273.;
		
		
			sprintf(cell->pstr,"%.1f \n%.0f " ,cell->press,cell->temp) ;
			cell->color = get_color( cell->press , cell->temp,cell->nID);
		}*/
 
	} 
	//if(g_hWnd!=NULL && IsWindow(g_hWnd))
	//{
	//	InvalidateRect(g_hWnd,NULL,TRUE);
	//	UpdateWindow(g_hWnd);
	//}
}/*
#include <list>
int  handle_w55_msg(HWND hWnd)
{
	int err = 0;
	int bHandled = FALSE; 
	
	std::list<std::string> filelist;
	char mbs[128] ;
	WIN32_FIND_DATA fndData;
	HANDLE hFind;
	hFind = FindFirstFile(L"\\DataOverIP\\IN\\*.W55", &fndData);	
	if (INVALID_HANDLE_VALUE != hFind) 	
	{
		do{
			wcstombs(mbs,fndData.cFileName,wcslen(fndData.cFileName)+1);
			filelist.push_back(mbs);
		}while(FindNextFile(hFind, &fndData));
		CloseHandle(hFind);
	}else return 0 ;
	//filelist.sort();
	std::list<std::string>::iterator it = filelist.begin();
	__alarmLog("handle_w55_msg, found %d files\n",filelist.size() ) ;
	while(it!=filelist.end())
	{
		std::string filepath = *it;
		char szPath[128];
		sprintf(szPath,"\\DataOverIP\\IN\\%s", it->c_str() );
		FILE* f = fopen( szPath,"rb");
		BYTE  buf[64];
		 
		if(f)
		{
			int n = fread(buf, 1, 63, f);
			int len = buf[0];
			int tmp = 0;
			fclose(f);
			TCHAR wcs[128];
			mbstowcs(wcs,szPath, strlen(szPath)+1);
			BOOL b = CleanupFile(wcs );
			reifen_callback( &buf[1]);		
			 
		}
		it++;
	}
 
	//if(bHandled )
	//{
	//	UPDATE_LE_LIST(hWnd,WM_USER_LECHIP, LE_UPDATE, 0);
	//}
	return bHandled ;
}*/

#else
#endif